#include "mozilla/dom/bindings/EventTargetBinding.h"
#include "mozilla/dom/bindings/XMLHttpRequestBinding.h"
#include "mozilla/dom/bindings/XMLHttpRequestUploadBinding.h"
#include "nsScriptNameSpaceManager.h"

namespace mozilla {
namespace dom {
namespace bindings {

void
Register(nsScriptNameSpaceManager* aNameSpaceManager)
{

#define REGISTER_PROTO(_dom_class) \
  aNameSpaceManager->RegisterDefineDOMInterface(NS_LITERAL_STRING(#_dom_class), prototypes::_dom_class::DefineDOMInterface);

REGISTER_PROTO(EventTarget);
REGISTER_PROTO(XMLHttpRequest);
REGISTER_PROTO(XMLHttpRequestUpload);

#undef REGISTER_PROTO
}

} // namespace bindings
} // namespace dom
} // namespace mozilla

