/* THIS FILE IS AUTOGENERATED - DO NOT EDIT */

#include "AccessCheck.h"
#include "WorkerPrivate.h"
#include "XPCQuickStubs.h"
#include "jsapi.h"
#include "mozilla/dom/bindings/EventListenerBinding.h"
#include "mozilla/dom/bindings/EventTargetBinding.h"
#include "mozilla/dom/bindings/Nullable.h"
#include "mozilla/dom/workers/bindings/EventTarget.h"
#include "nsContentUtils.h"
#include "nsDOMEventTargetHelper.h"
#include "nsIDOMEvent.h"
#include "nsIDOMEventListener.h"

namespace mozilla {
namespace dom {
namespace bindings {
namespace prototypes {

namespace EventTarget {

static JSBool
addEventListener(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  nsDOMEventTargetHelper* self;
  {
    nsresult rv = UnwrapObject<id::EventTarget>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<true>(cx, rv);
    }
  }

  if (argc < 2) {
    return Throw<true>(cx, NS_ERROR_XPC_NOT_ENOUGH_ARGS);
  }

  JS::Value* argv = JS_ARGV(cx, vp);

  xpc_qsDOMString arg0(cx, argv[0], &argv[0],
                       xpc_qsDOMString::eDefaultNullBehavior,
                       xpc_qsDOMString::eDefaultUndefinedBehavior);
  if (!arg0.IsValid()) {
    return false;
  }

  nsCOMPtr<nsIDOMEventListener> arg1;
  if (argv[1].isObject()) {
    nsresult rv;
    XPCCallContext ccx(JS_CALLER, cx);
    if (!ccx.IsValid()) {
      rv = NS_ERROR_XPC_BAD_CONVERT_JS;
      return Throw<true>(cx, rv);
    }

    const nsIID& iid = NS_GET_IID(nsIDOMEventListener);
    nsRefPtr<nsXPCWrappedJS> wrappedJS;
    rv = nsXPCWrappedJS::GetNewOrUsed(ccx, &argv[1].toObject(), iid,
                                      NULL, getter_AddRefs(wrappedJS));
    if (NS_FAILED(rv) || !wrappedJS) {
      return Throw<true>(cx, rv);
    }

    arg1 = do_QueryObject(wrappedJS.get());
    if (!arg1) {
      return Throw<true>(cx, rv);
    }
  } else if (argv[1].isNullOrUndefined()) {
    arg1 = NULL;
  } else {
    return Throw<true>(cx, NS_ERROR_XPC_BAD_CONVERT_JS);
  }

  JSBool arg2_jstype;
  bool arg2;
  if (JS_ValueToBoolean(cx, (2 < argc ? argv[2] : JSVAL_FALSE), &arg2_jstype)) {
    arg2 = ((bool)arg2_jstype);
  } else {
    return false;
  }

  JSBool arg3_jstype;
  Nullable<bool> arg3;
  if ((3 < argc ? argv[3] : JSVAL_NULL).isNullOrUndefined()) {
    arg3.SetNull();
  } else  if (JS_ValueToBoolean(cx, (3 < argc ? argv[3] : JSVAL_NULL), &arg3_jstype)) {
    arg3.SetValue((bool)arg3_jstype);
  } else {
    return false;
  }

  nsresult rv = NS_OK;
  self->AddEventListener(arg0, arg1, arg2, arg3, rv);
  if (NS_FAILED(rv)) {
    return ThrowMethodFailedWithDetails<true>(cx, rv, "EventTarget", "addEventListener");
  }
  *vp = JSVAL_VOID;
  return true;
}

static JSBool
removeEventListener(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  nsDOMEventTargetHelper* self;
  {
    nsresult rv = UnwrapObject<id::EventTarget>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<true>(cx, rv);
    }
  }

  if (argc < 2) {
    return Throw<true>(cx, NS_ERROR_XPC_NOT_ENOUGH_ARGS);
  }

  JS::Value* argv = JS_ARGV(cx, vp);

  xpc_qsDOMString arg0(cx, argv[0], &argv[0],
                       xpc_qsDOMString::eDefaultNullBehavior,
                       xpc_qsDOMString::eDefaultUndefinedBehavior);
  if (!arg0.IsValid()) {
    return false;
  }

  nsCOMPtr<nsIDOMEventListener> arg1;
  if (argv[1].isObject()) {
    nsresult rv;
    XPCCallContext ccx(JS_CALLER, cx);
    if (!ccx.IsValid()) {
      rv = NS_ERROR_XPC_BAD_CONVERT_JS;
      return Throw<true>(cx, rv);
    }

    const nsIID& iid = NS_GET_IID(nsIDOMEventListener);
    nsRefPtr<nsXPCWrappedJS> wrappedJS;
    rv = nsXPCWrappedJS::GetNewOrUsed(ccx, &argv[1].toObject(), iid,
                                      NULL, getter_AddRefs(wrappedJS));
    if (NS_FAILED(rv) || !wrappedJS) {
      return Throw<true>(cx, rv);
    }

    arg1 = do_QueryObject(wrappedJS.get());
    if (!arg1) {
      return Throw<true>(cx, rv);
    }
  } else if (argv[1].isNullOrUndefined()) {
    arg1 = NULL;
  } else {
    return Throw<true>(cx, NS_ERROR_XPC_BAD_CONVERT_JS);
  }

  JSBool arg2_jstype;
  bool arg2;
  if (JS_ValueToBoolean(cx, (2 < argc ? argv[2] : JSVAL_FALSE), &arg2_jstype)) {
    arg2 = ((bool)arg2_jstype);
  } else {
    return false;
  }

  nsresult rv = NS_OK;
  self->RemoveEventListener(arg0, arg1, arg2, rv);
  if (NS_FAILED(rv)) {
    return ThrowMethodFailedWithDetails<true>(cx, rv, "EventTarget", "removeEventListener");
  }
  *vp = JSVAL_VOID;
  return true;
}

static JSBool
dispatchEvent(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  nsDOMEventTargetHelper* self;
  {
    nsresult rv = UnwrapObject<id::EventTarget>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<true>(cx, rv);
    }
  }

  if (argc < 1) {
    return Throw<true>(cx, NS_ERROR_XPC_NOT_ENOUGH_ARGS);
  }

  JS::Value* argv = JS_ARGV(cx, vp);

  nsIDOMEvent* arg0;
  xpc_qsSelfRef tmpRef_arg0;
  jsval tmpVal_arg0 = argv[0];
  if (argv[0].isObject()) {
    nsIDOMEvent* tmp;
    if (NS_FAILED(xpc_qsUnwrapArg<nsIDOMEvent>(cx, argv[0], &tmp, &tmpRef_arg0.ptr,
                                               &tmpVal_arg0))) {
      return Throw<true>(cx, NS_ERROR_XPC_BAD_CONVERT_JS);
    }
    MOZ_ASSERT(tmp);
    arg0 = tmp;
  } else {
    return Throw<true>(cx, NS_ERROR_XPC_BAD_CONVERT_JS);
  }

  nsresult rv = NS_OK;
  bool result;
  result = self->DispatchEvent(arg0, rv);
  if (NS_FAILED(rv)) {
    return ThrowMethodFailedWithDetails<true>(cx, rv, "EventTarget", "dispatchEvent");
  }
  *vp = BOOLEAN_TO_JSVAL(result);
  return true;
}

const NativePropertyHooks NativeHooks = { ResolveProperty, EnumerateProperties, NULL };

static JSBool
_HasInstance(JSContext* cx, JSObject* obj, const jsval* v, JSBool* bp)
{
  if (!v->isObject()) {
    *bp = false;
    return true;
  }

  jsval protov;
  if (!JS_GetProperty(cx, obj, "prototype", &protov))
    return false;
  if (!protov.isObject()) {
    JS_ReportErrorNumber(cx, js_GetErrorMessage, NULL, JSMSG_BAD_PROTOTYPE,
                         "EventTarget");
    return false;
  }
  obj = &protov.toObject();

  JSObject* instance = &v->toObject();
  JSObject* proto = JS_GetPrototype(instance);
  while (proto) {
    if (proto == obj) {
      *bp = true;
      return true;
    }
    proto = JS_GetPrototype(proto);
  }

  nsISupports* native =
    nsContentUtils::XPConnect()->GetNativeOfWrapper(cx, instance);
  nsCOMPtr<nsIDOMEventTarget> qiResult = do_QueryInterface(native);
  *bp = !!qiResult;
  return true;

}

static JSClass InterfaceObjectClass = {
  "Function", 0,
  JS_PropertyStub,       /* addProperty */
  JS_PropertyStub,       /* delProperty */
  JS_PropertyStub,       /* getProperty */
  JS_StrictPropertyStub, /* setProperty */
  JS_EnumerateStub,
  JS_ResolveStub,
  JS_ConvertStub,
  NULL,                  /* finalize */
  NULL,                  /* checkAccess */
  NULL, /* call */
  NULL, /* construct */
  _HasInstance, /* hasInstance */
  NULL,                  /* trace */
  JSCLASS_NO_INTERNAL_MEMBERS
};

static JSClass PrototypeClass = {
  "EventTarget Prototype", 0,
  JS_PropertyStub,       /* addProperty */
  JS_PropertyStub,       /* delProperty */
  JS_PropertyStub,       /* getProperty */
  JS_StrictPropertyStub, /* setProperty */
  JS_EnumerateStub,
  JS_ResolveStub,
  JS_ConvertStub,
  NULL,                  /* finalize */
  NULL,                  /* checkAccess */
  NULL,                  /* call */
  NULL,                  /* construct */
  NULL,                  /* hasInstance */
  NULL,                  /* trace */
  JSCLASS_NO_INTERNAL_MEMBERS
};
static JSFunctionSpec sMethods[] = {
  JS_FN("addEventListener", addEventListener, 4, JSPROP_ENUMERATE),
  JS_FN("removeEventListener", removeEventListener, 3, JSPROP_ENUMERATE),
  JS_FN("dispatchEvent", dispatchEvent, 1, JSPROP_ENUMERATE),
  JS_FN("QueryInterface", QueryInterface, 1, 0),
  JS_FS_END
};

static jsid sMethods_ids[4] = { JSID_VOID };


JSObject*
CreateInterfaceObjects(JSContext* aCx, JSObject* aGlobal, JSObject* aReceiver)
{
  if (sMethods_ids[0] == JSID_VOID &&
      !InitIds(aCx, sMethods, sMethods_ids)) {
    sMethods_ids[0] = JSID_VOID;
    return NULL;
  }

  JSObject* parentProto = JS_GetObjectPrototype(aCx, aGlobal);
  if (!parentProto) {
    return NULL;
  }
  return bindings::CreateInterfaceObjects(aCx, aGlobal, aReceiver, parentProto,
                                          &PrototypeClass, &InterfaceObjectClass, NULL, 0,
                                          sMethods, NULL, NULL, NULL,
                                          "EventTarget");
}

bool
ResolveProperty(JSContext* cx, JSObject* wrapper, jsid id, bool set, JSPropertyDescriptor* desc)
{
  for (size_t i = 0; i < ArrayLength(sMethods_ids); ++i) {
    if (id == sMethods_ids[i]) {
      JSFunction *fun = JS_NewFunctionById(cx, sMethods[i].call, sMethods[i].nargs, 0, wrapper, id);
      if (!fun)
          return false;
      JSObject *funobj = JS_GetFunctionObject(fun);
      desc->value.setObject(*funobj);
      desc->attrs = sMethods[i].flags;
      desc->obj = wrapper;
      desc->setter = nsnull;
      desc->getter = nsnull;
      return true;
    }
  }

  return true;
}

bool
EnumerateProperties(JS::AutoIdVector& props)
{
  for (size_t i = 0; i < sizeof(sMethods_ids); ++i) {
    if ((sMethods[i].flags & JSPROP_ENUMERATE) &&
        !props.append(sMethods_ids[i])) {
      return false;
    }
  }

  return true;
}

bool
DefineDOMInterface(JSContext* aCx, JSObject* aReceiver, bool* aEnabled)
{
  JSObject* global = JS_GetGlobalForObject(aCx, aReceiver);

  {
    XPCWrappedNativeScope* scope =
      XPCWrappedNativeScope::FindInJSObjectScope(aCx, global);
    if (!scope) {
      return false;
    }

    if (!scope->ParisBindingsEnabled()) {
      *aEnabled = false;
      return false;
    }
  }

  *aEnabled = true;
  return !!GetProtoObject(aCx, global, aReceiver);
}

} // namespace EventTarget

namespace EventTarget_workers {

static JSBool
addEventListener(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  mozilla::dom::workers::EventTarget* self;
  {
    nsresult rv = UnwrapObject<id::EventTarget_workers>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<false>(cx, rv);
    }
  }

  if (argc < 2) {
    return Throw<false>(cx, NS_ERROR_XPC_NOT_ENOUGH_ARGS);
  }

  JS::Value* argv = JS_ARGV(cx, vp);

  xpc_qsDOMString arg0(cx, argv[0], &argv[0],
                       xpc_qsDOMString::eDefaultNullBehavior,
                       xpc_qsDOMString::eDefaultUndefinedBehavior);
  if (!arg0.IsValid()) {
    return false;
  }

  JSObject* arg1;
  if (argv[1].isObject()) {
    arg1 = &argv[1].toObject();
  } else if (argv[1].isNullOrUndefined()) {
    arg1 = NULL;
  } else {
    return Throw<false>(cx, NS_ERROR_XPC_BAD_CONVERT_JS);
  }

  JSBool arg2_jstype;
  bool arg2;
  if (JS_ValueToBoolean(cx, (2 < argc ? argv[2] : JSVAL_FALSE), &arg2_jstype)) {
    arg2 = ((bool)arg2_jstype);
  } else {
    return false;
  }

  JSBool arg3_jstype;
  Nullable<bool> arg3;
  if ((3 < argc ? argv[3] : JSVAL_NULL).isNullOrUndefined()) {
    arg3.SetNull();
  } else  if (JS_ValueToBoolean(cx, (3 < argc ? argv[3] : JSVAL_NULL), &arg3_jstype)) {
    arg3.SetValue((bool)arg3_jstype);
  } else {
    return false;
  }

  nsresult rv = NS_OK;
  self->AddEventListener(arg0, arg1, arg2, arg3, rv);
  if (NS_FAILED(rv)) {
    return ThrowMethodFailedWithDetails<false>(cx, rv, "EventTarget", "addEventListener");
  }
  *vp = JSVAL_VOID;
  return true;
}

static JSBool
removeEventListener(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  mozilla::dom::workers::EventTarget* self;
  {
    nsresult rv = UnwrapObject<id::EventTarget_workers>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<false>(cx, rv);
    }
  }

  if (argc < 2) {
    return Throw<false>(cx, NS_ERROR_XPC_NOT_ENOUGH_ARGS);
  }

  JS::Value* argv = JS_ARGV(cx, vp);

  xpc_qsDOMString arg0(cx, argv[0], &argv[0],
                       xpc_qsDOMString::eDefaultNullBehavior,
                       xpc_qsDOMString::eDefaultUndefinedBehavior);
  if (!arg0.IsValid()) {
    return false;
  }

  JSObject* arg1;
  if (argv[1].isObject()) {
    arg1 = &argv[1].toObject();
  } else if (argv[1].isNullOrUndefined()) {
    arg1 = NULL;
  } else {
    return Throw<false>(cx, NS_ERROR_XPC_BAD_CONVERT_JS);
  }

  JSBool arg2_jstype;
  bool arg2;
  if (JS_ValueToBoolean(cx, (2 < argc ? argv[2] : JSVAL_FALSE), &arg2_jstype)) {
    arg2 = ((bool)arg2_jstype);
  } else {
    return false;
  }

  nsresult rv = NS_OK;
  self->RemoveEventListener(arg0, arg1, arg2, rv);
  if (NS_FAILED(rv)) {
    return ThrowMethodFailedWithDetails<false>(cx, rv, "EventTarget", "removeEventListener");
  }
  *vp = JSVAL_VOID;
  return true;
}

static JSBool
dispatchEvent(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  mozilla::dom::workers::EventTarget* self;
  {
    nsresult rv = UnwrapObject<id::EventTarget_workers>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<false>(cx, rv);
    }
  }

  if (argc < 1) {
    return Throw<false>(cx, NS_ERROR_XPC_NOT_ENOUGH_ARGS);
  }

  JS::Value* argv = JS_ARGV(cx, vp);

  JSObject* arg0;
  if (argv[0].isObject()) {
    arg0 = &argv[0].toObject();
    MOZ_ASSERT(arg0);
  } else {
    return Throw<false>(cx, NS_ERROR_XPC_BAD_CONVERT_JS);
  }

  nsresult rv = NS_OK;
  bool result;
  result = self->DispatchEvent(arg0, rv);
  if (NS_FAILED(rv)) {
    return ThrowMethodFailedWithDetails<false>(cx, rv, "EventTarget", "dispatchEvent");
  }
  *vp = BOOLEAN_TO_JSVAL(result);
  return true;
}

const NativePropertyHooks NativeHooks = { ResolveProperty, EnumerateProperties, NULL };

static JSClass PrototypeClass = {
  "EventTarget Prototype", 0,
  JS_PropertyStub,       /* addProperty */
  JS_PropertyStub,       /* delProperty */
  JS_PropertyStub,       /* getProperty */
  JS_StrictPropertyStub, /* setProperty */
  JS_EnumerateStub,
  JS_ResolveStub,
  JS_ConvertStub,
  NULL,                  /* finalize */
  NULL,                  /* checkAccess */
  NULL,                  /* call */
  NULL,                  /* construct */
  NULL,                  /* hasInstance */
  NULL,                  /* trace */
  JSCLASS_NO_INTERNAL_MEMBERS
};
static JSFunctionSpec sMethods[] = {
  JS_FN("addEventListener", addEventListener, 4, JSPROP_ENUMERATE),
  JS_FN("removeEventListener", removeEventListener, 3, JSPROP_ENUMERATE),
  JS_FN("dispatchEvent", dispatchEvent, 1, JSPROP_ENUMERATE),
  JS_FS_END
};

static jsid sMethods_ids[3] = { JSID_VOID };


JSObject*
CreateInterfaceObjects(JSContext* aCx, JSObject* aGlobal, JSObject* aReceiver)
{
  if (sMethods_ids[0] == JSID_VOID &&
      !InitIds(aCx, sMethods, sMethods_ids)) {
    sMethods_ids[0] = JSID_VOID;
    return NULL;
  }

  JSObject* parentProto = JS_GetObjectPrototype(aCx, aGlobal);
  if (!parentProto) {
    return NULL;
  }
  return bindings::CreateInterfaceObjects(aCx, aGlobal, aReceiver, parentProto,
                                          &PrototypeClass, NULL, ThrowingConstructorWorkers, 0,
                                          sMethods, NULL, NULL, NULL,
                                          "EventTarget");
}

bool
ResolveProperty(JSContext* cx, JSObject* wrapper, jsid id, bool set, JSPropertyDescriptor* desc)
{
  for (size_t i = 0; i < ArrayLength(sMethods_ids); ++i) {
    if (id == sMethods_ids[i]) {
      JSFunction *fun = JS_NewFunctionById(cx, sMethods[i].call, sMethods[i].nargs, 0, wrapper, id);
      if (!fun)
          return false;
      JSObject *funobj = JS_GetFunctionObject(fun);
      desc->value.setObject(*funobj);
      desc->attrs = sMethods[i].flags;
      desc->obj = wrapper;
      desc->setter = nsnull;
      desc->getter = nsnull;
      return true;
    }
  }

  return true;
}

bool
EnumerateProperties(JS::AutoIdVector& props)
{
  for (size_t i = 0; i < sizeof(sMethods_ids); ++i) {
    if ((sMethods[i].flags & JSPROP_ENUMERATE) &&
        !props.append(sMethods_ids[i])) {
      return false;
    }
  }

  return true;
}

} // namespace EventTarget_workers

} // namespace prototypes
} // namespace bindings
} // namespace dom
} // namespace mozilla