/* THIS FILE IS AUTOGENERATED - DO NOT EDIT */

#include "AccessCheck.h"
#include "WorkerPrivate.h"
#include "XPCQuickStubs.h"
#include "jsapi.h"
#include "jsfriendapi.h"
#include "mozilla/dom/bindings/EventTargetBinding.h"
#include "mozilla/dom/bindings/Nullable.h"
#include "mozilla/dom/bindings/XMLHttpRequestBinding.h"
#include "mozilla/dom/bindings/XMLHttpRequestEventTargetBinding.h"
#include "mozilla/dom/bindings/XMLHttpRequestUploadBinding.h"
#include "mozilla/dom/workers/bindings/XMLHttpRequest.h"
#include "mozilla/dom/workers/bindings/XMLHttpRequestUpload.h"
#include "nsContentUtils.h"
#include "nsIChannel.h"
#include "nsIDOMFile.h"
#include "nsIDOMFormData.h"
#include "nsIDocument.h"
#include "nsIInputStream.h"
#include "nsXMLHttpRequest.h"
#include "xpcjsid.h"

namespace mozilla {
namespace dom {
namespace bindings {
namespace prototypes {

namespace XMLHttpRequestResponseType {

  const EnumEntry strings[10] = {
    {"", 0},
    {"arraybuffer", 11},
    {"blob", 4},
    {"document", 8},
    {"json", 4},
    {"text", 4},
    {"moz-chunked-text", 16},
    {"moz-chunked-arraybuffer", 23},
    {"moz-blob", 8},
    { NULL, 0 }
  };
} // namespace XMLHttpRequestResponseType

namespace XMLHttpRequest {

static JSBool
open(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  nsXMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<true>(cx, rv);
    }
  }

  if (argc < 2) {
    return Throw<true>(cx, NS_ERROR_XPC_NOT_ENOUGH_ARGS);
  }

  JS::Value* argv = JS_ARGV(cx, vp);

  xpc_qsDOMString arg0(cx, argv[0], &argv[0],
                       xpc_qsDOMString::eDefaultNullBehavior,
                       xpc_qsDOMString::eDefaultUndefinedBehavior);
  if (!arg0.IsValid()) {
    return false;
  }

  xpc_qsDOMString arg1(cx, argv[1], &argv[1],
                       xpc_qsDOMString::eDefaultNullBehavior,
                       xpc_qsDOMString::eDefaultUndefinedBehavior);
  if (!arg1.IsValid()) {
    return false;
  }

  JSBool arg2_jstype;
  bool arg2;
  if (JS_ValueToBoolean(cx, (2 < argc ? argv[2] : JSVAL_TRUE), &arg2_jstype)) {
    arg2 = ((bool)arg2_jstype);
  } else {
    return false;
  }

  xpc_qsDOMString arg3(cx, (3 < argc ? argv[3] : JSVAL_VOID), (3 < argc ? &argv[3] : NULL),
                       xpc_qsDOMString::eNull,
                       xpc_qsDOMString::eNull);
  if (!arg3.IsValid()) {
    return false;
  }

  xpc_qsDOMString arg4(cx, (4 < argc ? argv[4] : JSVAL_VOID), (4 < argc ? &argv[4] : NULL),
                       xpc_qsDOMString::eNull,
                       xpc_qsDOMString::eNull);
  if (!arg4.IsValid()) {
    return false;
  }

  nsresult rv = NS_OK;
  self->Open(arg0, arg1, arg2, arg3, arg4, rv);
  if (NS_FAILED(rv)) {
    return ThrowMethodFailedWithDetails<true>(cx, rv, "XMLHttpRequest", "open");
  }
  *vp = JSVAL_VOID;
  return true;
}

static JSBool
setRequestHeader(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  nsXMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<true>(cx, rv);
    }
  }

  if (argc < 2) {
    return Throw<true>(cx, NS_ERROR_XPC_NOT_ENOUGH_ARGS);
  }

  JS::Value* argv = JS_ARGV(cx, vp);

  xpc_qsDOMString arg0(cx, argv[0], &argv[0],
                       xpc_qsDOMString::eDefaultNullBehavior,
                       xpc_qsDOMString::eDefaultUndefinedBehavior);
  if (!arg0.IsValid()) {
    return false;
  }

  xpc_qsDOMString arg1(cx, argv[1], &argv[1],
                       xpc_qsDOMString::eDefaultNullBehavior,
                       xpc_qsDOMString::eDefaultUndefinedBehavior);
  if (!arg1.IsValid()) {
    return false;
  }

  nsresult rv = NS_OK;
  self->SetRequestHeader(arg0, arg1, rv);
  if (NS_FAILED(rv)) {
    return ThrowMethodFailedWithDetails<true>(cx, rv, "XMLHttpRequest", "setRequestHeader");
  }
  *vp = JSVAL_VOID;
  return true;
}

static JSBool
send(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  nsXMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<true>(cx, rv);
    }
  }

  unsigned argcount = NS_MIN(argc, 1u);
  switch (argcount) {
    case 0: {
      nsresult rv = NS_OK;
      self->Send(cx, rv);
      if (NS_FAILED(rv)) {
        return ThrowMethodFailedWithDetails<true>(cx, rv, "XMLHttpRequest", "send");
      }
      *vp = JSVAL_VOID;
      return true;
      break;
    }
    case 1: {
      JS::Value* argv_start = JS_ARGV(cx, vp);
      if (argv_start[0].isNullOrUndefined()) {

        JS::Value* argv = JS_ARGV(cx, vp);

        xpc_qsDOMString arg0(cx, argv[0], &argv[0],
                             xpc_qsDOMString::eNull,
                             xpc_qsDOMString::eNull);
        if (!arg0.IsValid()) {
          return false;
        }

        nsresult rv = NS_OK;
        self->Send(cx, arg0, rv);
        if (NS_FAILED(rv)) {
          return ThrowMethodFailedWithDetails<true>(cx, rv, "XMLHttpRequest", "send");
        }
        *vp = JSVAL_VOID;
        return true;
      }
      if (argv_start[0].isObject() && JS_IsArrayBufferObject(&argv_start[0].toObject(), cx)) {

        JS::Value* argv = JS_ARGV(cx, vp);

        JSObject* arg0;
        if (argv[0].isObject() && JS_IsArrayBufferObject(&argv[0].toObject(), cx)) {
          arg0 = &argv[0].toObject();
        } else {
          return Throw<false>(cx, NS_ERROR_XPC_BAD_CONVERT_JS);
        }
        nsresult rv = NS_OK;
        self->Send(cx, arg0, rv);
        if (NS_FAILED(rv)) {
          return ThrowMethodFailedWithDetails<true>(cx, rv, "XMLHttpRequest", "send");
        }
        *vp = JSVAL_VOID;
        return true;
      }
      if (argv_start[0].isObject() &&
          IsPlatformObject(cx, &argv_start[0].toObject())) {
        do {
          nsIDOMBlob* arg0;
          xpc_qsSelfRef tmpRef_arg0;
          jsval tmpVal_arg0 = argv_start[0];

          nsIDOMBlob* tmp;
          if (NS_FAILED(xpc_qsUnwrapArg<nsIDOMBlob>(cx, argv_start[0], &tmp, &tmpRef_arg0.ptr,
                                                     &tmpVal_arg0))) {
            break;
          }
          MOZ_ASSERT(tmp);
          arg0 = tmp;

          nsresult rv = NS_OK;
          self->Send(cx, arg0, rv);
          if (NS_FAILED(rv)) {
            return ThrowMethodFailedWithDetails<true>(cx, rv, "XMLHttpRequest", "send");
          }
          *vp = JSVAL_VOID;
          return true;
        } while (0);
        do {
          nsIDocument* arg0;
          xpc_qsSelfRef tmpRef_arg0;
          jsval tmpVal_arg0 = argv_start[0];

          nsIDocument* tmp;
          if (NS_FAILED(xpc_qsUnwrapArg<nsIDocument>(cx, argv_start[0], &tmp, &tmpRef_arg0.ptr,
                                                     &tmpVal_arg0))) {
            break;
          }
          MOZ_ASSERT(tmp);
          arg0 = tmp;

          nsresult rv = NS_OK;
          self->Send(cx, arg0, rv);
          if (NS_FAILED(rv)) {
            return ThrowMethodFailedWithDetails<true>(cx, rv, "XMLHttpRequest", "send");
          }
          *vp = JSVAL_VOID;
          return true;
        } while (0);
        do {
          nsIDOMFormData* arg0;
          xpc_qsSelfRef tmpRef_arg0;
          jsval tmpVal_arg0 = argv_start[0];

          nsIDOMFormData* tmp;
          if (NS_FAILED(xpc_qsUnwrapArg<nsIDOMFormData>(cx, argv_start[0], &tmp, &tmpRef_arg0.ptr,
                                                     &tmpVal_arg0))) {
            break;
          }
          MOZ_ASSERT(tmp);
          arg0 = tmp;

          nsresult rv = NS_OK;
          self->Send(cx, arg0, rv);
          if (NS_FAILED(rv)) {
            return ThrowMethodFailedWithDetails<true>(cx, rv, "XMLHttpRequest", "send");
          }
          *vp = JSVAL_VOID;
          return true;
        } while (0);
        do {
          nsIInputStream* arg0;
          xpc_qsSelfRef tmpRef_arg0;
          jsval tmpVal_arg0 = argv_start[0];

          nsIInputStream* tmp;
          if (NS_FAILED(xpc_qsUnwrapArg<nsIInputStream>(cx, argv_start[0], &tmp, &tmpRef_arg0.ptr,
                                                     &tmpVal_arg0))) {
            break;
          }
          MOZ_ASSERT(tmp);
          arg0 = tmp;

          nsresult rv = NS_OK;
          self->Send(cx, arg0, rv);
          if (NS_FAILED(rv)) {
            return ThrowMethodFailedWithDetails<true>(cx, rv, "XMLHttpRequest", "send");
          }
          *vp = JSVAL_VOID;
          return true;
        } while (0);
      }

      JS::Value* argv = JS_ARGV(cx, vp);

      xpc_qsDOMString arg0(cx, argv[0], &argv[0],
                           xpc_qsDOMString::eNull,
                           xpc_qsDOMString::eNull);
      if (!arg0.IsValid()) {
        return false;
      }

      nsresult rv = NS_OK;
      self->Send(cx, arg0, rv);
      if (NS_FAILED(rv)) {
        return ThrowMethodFailedWithDetails<true>(cx, rv, "XMLHttpRequest", "send");
      }
      *vp = JSVAL_VOID;
      return true;
      break;
    }
    default: {
      return Throw<true>(cx, NS_ERROR_XPC_NOT_ENOUGH_ARGS);
      break;
    }
  }
  MOZ_NOT_REACHED("We have an always-returning default case");
  return false;
}

static JSBool
abort(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  nsXMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<true>(cx, rv);
    }
  }
  self->Abort();
  *vp = JSVAL_VOID;
  return true;
}

static JSBool
getResponseHeader(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  nsXMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<true>(cx, rv);
    }
  }

  if (argc < 1) {
    return Throw<true>(cx, NS_ERROR_XPC_NOT_ENOUGH_ARGS);
  }

  JS::Value* argv = JS_ARGV(cx, vp);

  xpc_qsDOMString arg0(cx, argv[0], &argv[0],
                       xpc_qsDOMString::eDefaultNullBehavior,
                       xpc_qsDOMString::eDefaultUndefinedBehavior);
  if (!arg0.IsValid()) {
    return false;
  }

  nsresult rv = NS_OK;
  nsString result;
  self->GetResponseHeader(arg0, result, rv);
  if (NS_FAILED(rv)) {
    return ThrowMethodFailedWithDetails<true>(cx, rv, "XMLHttpRequest", "getResponseHeader");
  }
  return xpc::StringToJsval(cx, result, vp);
}

static JSBool
getAllResponseHeaders(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  nsXMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<true>(cx, rv);
    }
  }
  nsString result;
  self->GetAllResponseHeaders(result);
  return xpc::NonVoidStringToJsval(cx, result, vp);
}

static JSBool
overrideMimeType(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  nsXMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<true>(cx, rv);
    }
  }

  if (argc < 1) {
    return Throw<true>(cx, NS_ERROR_XPC_NOT_ENOUGH_ARGS);
  }

  JS::Value* argv = JS_ARGV(cx, vp);

  xpc_qsDOMString arg0(cx, argv[0], &argv[0],
                       xpc_qsDOMString::eDefaultNullBehavior,
                       xpc_qsDOMString::eDefaultUndefinedBehavior);
  if (!arg0.IsValid()) {
    return false;
  }

  self->OverrideMimeType(arg0);
  *vp = JSVAL_VOID;
  return true;
}

static JSBool
sendAsBinary(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  nsXMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<true>(cx, rv);
    }
  }

  if (argc < 1) {
    return Throw<true>(cx, NS_ERROR_XPC_NOT_ENOUGH_ARGS);
  }

  JS::Value* argv = JS_ARGV(cx, vp);

  xpc_qsDOMString arg0(cx, argv[0], &argv[0],
                       xpc_qsDOMString::eDefaultNullBehavior,
                       xpc_qsDOMString::eDefaultUndefinedBehavior);
  if (!arg0.IsValid()) {
    return false;
  }

  nsresult rv = NS_OK;
  self->SendAsBinary(cx, arg0, rv);
  if (NS_FAILED(rv)) {
    return ThrowMethodFailedWithDetails<true>(cx, rv, "XMLHttpRequest", "sendAsBinary");
  }
  *vp = JSVAL_VOID;
  return true;
}

static JSBool
getInterface(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  nsXMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<true>(cx, rv);
    }
  }

  if (argc < 1) {
    return Throw<true>(cx, NS_ERROR_XPC_NOT_ENOUGH_ARGS);
  }

  JS::Value* argv = JS_ARGV(cx, vp);

  nsIJSIID* arg0;
  xpc_qsSelfRef tmpRef_arg0;
  jsval tmpVal_arg0 = argv[0];
  if (argv[0].isObject()) {
    nsIJSIID* tmp;
    if (NS_FAILED(xpc_qsUnwrapArg<nsIJSIID>(cx, argv[0], &tmp, &tmpRef_arg0.ptr,
                                               &tmpVal_arg0))) {
      return Throw<true>(cx, NS_ERROR_XPC_BAD_CONVERT_JS);
    }
    MOZ_ASSERT(tmp);
    arg0 = tmp;
  } else {
    return Throw<true>(cx, NS_ERROR_XPC_BAD_CONVERT_JS);
  }

  nsresult rv = NS_OK;
  JS::Value result;
  result = self->GetInterface(cx, arg0, rv);
  if (NS_FAILED(rv)) {
    return ThrowMethodFailedWithDetails<true>(cx, rv, "XMLHttpRequest", "getInterface");
  }
  *vp = result;

  return JS_WrapValue(cx, vp);
}

static JSBool
get_onreadystatechange(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  nsXMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<true>(cx, rv);
    }
  }
  JSObject* result;
  result = self->GetOnreadystatechange();
  *vp = JS::ObjectOrNullValue(result);
  return JS_WrapValue(cx, vp);
}

static JSBool
get_readyState(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  nsXMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<true>(cx, rv);
    }
  }
  uint16_t result;
  result = self->GetReadyState();
  *vp = INT_TO_JSVAL(int32_t(result));
  return true;
}

static JSBool
get_timeout(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  nsXMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<true>(cx, rv);
    }
  }
  uint32_t result;
  result = self->GetTimeout();
  *vp = UINT_TO_JSVAL(result);
  return true;
}

static JSBool
get_withCredentials(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  nsXMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<true>(cx, rv);
    }
  }
  bool result;
  result = self->GetWithCredentials();
  *vp = BOOLEAN_TO_JSVAL(result);
  return true;
}

static JSBool
get_upload(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  nsXMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<true>(cx, rv);
    }
  }
  nsXMLHttpRequestUpload* result;
  result = self->GetUpload();
  if (WrapNewBindingObject(cx, obj, result, vp)) {
    return true;
  }
  return HandleNewBindingWrappingFailure(cx, obj, result, vp);
}

static JSBool
get_status(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  nsXMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<true>(cx, rv);
    }
  }
  uint16_t result;
  result = self->GetStatus();
  *vp = INT_TO_JSVAL(int32_t(result));
  return true;
}

static JSBool
get_statusText(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  nsXMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<true>(cx, rv);
    }
  }
  nsString result;
  self->GetStatusText(result);
  return xpc::NonVoidStringToJsval(cx, result, vp);
}

static JSBool
get_responseType(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  nsXMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<true>(cx, rv);
    }
  }
  XMLHttpRequestResponseType::value result;
  result = self->GetResponseType();
  MOZ_ASSERT(uint32_t(result) < ArrayLength(XMLHttpRequestResponseType::strings));
  JSString* result_str = JS_NewStringCopyN(cx, XMLHttpRequestResponseType::strings[uint32_t(result)].value, XMLHttpRequestResponseType::strings[uint32_t(result)].length);
  if (!result_str) {
    return false;
  }
  *vp = JS::StringValue(result_str);
  return true;
}

static JSBool
get_response(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  nsXMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<true>(cx, rv);
    }
  }
  nsresult rv = NS_OK;
  JS::Value result;
  result = self->GetResponse(cx, rv);
  if (NS_FAILED(rv)) {
    return ThrowMethodFailedWithDetails<true>(cx, rv, "XMLHttpRequest", "response");
  }
  *vp = result;

  return JS_WrapValue(cx, vp);
}

static JSBool
get_responseText(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  nsXMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<true>(cx, rv);
    }
  }
  nsresult rv = NS_OK;
  nsString result;
  self->GetResponseText(result, rv);
  if (NS_FAILED(rv)) {
    return ThrowMethodFailedWithDetails<true>(cx, rv, "XMLHttpRequest", "responseText");
  }
  return xpc::StringToJsval(cx, result, vp);
}

static JSBool
get_responseXML(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  nsXMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<true>(cx, rv);
    }
  }
  nsresult rv = NS_OK;
  nsIDocument* result;
  result = self->GetResponseXML(rv);
  if (NS_FAILED(rv)) {
    return ThrowMethodFailedWithDetails<true>(cx, rv, "XMLHttpRequest", "responseXML");
  }
  if (!result) {
    *vp = JSVAL_NULL;
    return true;
  }
  return WrapObject(cx, obj, result, vp);
}

static JSBool
get_multipart(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  nsXMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<true>(cx, rv);
    }
  }
  bool result;
  result = self->GetMultipart();
  *vp = BOOLEAN_TO_JSVAL(result);
  return true;
}

static JSBool
get_mozBackgroundRequest(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  nsXMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<true>(cx, rv);
    }
  }
  bool result;
  result = self->GetMozBackgroundRequest();
  *vp = BOOLEAN_TO_JSVAL(result);
  return true;
}

static JSBool
get_channel(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  nsXMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<true>(cx, rv);
    }
  }
  nsRefPtr<nsIChannel> result;
  result = self->GetChannel();
  return WrapObject(cx, obj, result, &NS_GET_IID(nsIChannel), vp);
}

static JSBool
get_onuploadprogress(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  nsXMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<true>(cx, rv);
    }
  }
  JSObject* result;
  result = self->GetOnuploadprogress();
  *vp = JS::ObjectOrNullValue(result);
  return JS_WrapValue(cx, vp);
}

static JSBool
set_onreadystatechange(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  nsXMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<true>(cx, rv);
    }
  }

  JS::Value* argv = JS_ARGV(cx, vp);
  jsval undef = JS::UndefinedValue();
  if (argc == 0) {
    argv = &undef;
    argc = 1;
  }
  JSObject* arg0;
  if (argv[0].isObject() && JS_ObjectIsCallable(cx, &argv[0].toObject())) {
    arg0 = &argv[0].toObject();
  } else {
    arg0 = NULL;
  }

  nsresult rv = NS_OK;
  self->SetOnreadystatechange(cx, arg0, rv);
  if (NS_FAILED(rv)) {
    return ThrowMethodFailedWithDetails<true>(cx, rv, "XMLHttpRequest", "onreadystatechange");
  }
  *vp = JSVAL_VOID;
  return true;
}

static JSBool
set_timeout(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  nsXMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<true>(cx, rv);
    }
  }

  JS::Value* argv = JS_ARGV(cx, vp);
  jsval undef = JS::UndefinedValue();
  if (argc == 0) {
    argv = &undef;
    argc = 1;
  }
  int32_t arg0_jstype;
  uint32_t arg0;
  if (JS::ToInt32(cx, argv[0], &arg0_jstype)) {
    arg0 = ((uint32_t)arg0_jstype);
  } else {
    return false;
  }

  nsresult rv = NS_OK;
  self->SetTimeout(arg0, rv);
  if (NS_FAILED(rv)) {
    return ThrowMethodFailedWithDetails<true>(cx, rv, "XMLHttpRequest", "timeout");
  }
  *vp = JSVAL_VOID;
  return true;
}

static JSBool
set_withCredentials(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  nsXMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<true>(cx, rv);
    }
  }

  JS::Value* argv = JS_ARGV(cx, vp);
  jsval undef = JS::UndefinedValue();
  if (argc == 0) {
    argv = &undef;
    argc = 1;
  }
  JSBool arg0_jstype;
  bool arg0;
  if (JS_ValueToBoolean(cx, argv[0], &arg0_jstype)) {
    arg0 = ((bool)arg0_jstype);
  } else {
    return false;
  }

  self->SetWithCredentials(arg0);
  *vp = JSVAL_VOID;
  return true;
}

static JSBool
set_responseType(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  nsXMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<true>(cx, rv);
    }
  }

  JS::Value* argv = JS_ARGV(cx, vp);
  jsval undef = JS::UndefinedValue();
  if (argc == 0) {
    argv = &undef;
    argc = 1;
  }
  XMLHttpRequestResponseType::value arg0;
  {
    bool ok;
    int index = FindEnumStringIndex(cx, argv[0], XMLHttpRequestResponseType::strings, &ok);
    if (!ok) {
      return false;
    }
    if (index < 0) {
      return true;
    }
    arg0 = static_cast<XMLHttpRequestResponseType::value>(index);
  }
  nsresult rv = NS_OK;
  self->SetResponseType(arg0, rv);
  if (NS_FAILED(rv)) {
    return ThrowMethodFailedWithDetails<true>(cx, rv, "XMLHttpRequest", "responseType");
  }
  *vp = JSVAL_VOID;
  return true;
}

static JSBool
set_multipart(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  nsXMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<true>(cx, rv);
    }
  }

  JS::Value* argv = JS_ARGV(cx, vp);
  jsval undef = JS::UndefinedValue();
  if (argc == 0) {
    argv = &undef;
    argc = 1;
  }
  JSBool arg0_jstype;
  bool arg0;
  if (JS_ValueToBoolean(cx, argv[0], &arg0_jstype)) {
    arg0 = ((bool)arg0_jstype);
  } else {
    return false;
  }

  self->SetMultipart(arg0);
  *vp = JSVAL_VOID;
  return true;
}

static JSBool
set_mozBackgroundRequest(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  nsXMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<true>(cx, rv);
    }
  }

  JS::Value* argv = JS_ARGV(cx, vp);
  jsval undef = JS::UndefinedValue();
  if (argc == 0) {
    argv = &undef;
    argc = 1;
  }
  JSBool arg0_jstype;
  bool arg0;
  if (JS_ValueToBoolean(cx, argv[0], &arg0_jstype)) {
    arg0 = ((bool)arg0_jstype);
  } else {
    return false;
  }

  self->SetMozBackgroundRequest(arg0);
  *vp = JSVAL_VOID;
  return true;
}

static JSBool
set_onuploadprogress(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  nsXMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<true>(cx, rv);
    }
  }

  JS::Value* argv = JS_ARGV(cx, vp);
  jsval undef = JS::UndefinedValue();
  if (argc == 0) {
    argv = &undef;
    argc = 1;
  }
  JSObject* arg0;
  if (argv[0].isObject() && JS_ObjectIsCallable(cx, &argv[0].toObject())) {
    arg0 = &argv[0].toObject();
  } else {
    arg0 = NULL;
  }

  nsresult rv = NS_OK;
  self->SetOnuploadprogress(cx, arg0, rv);
  if (NS_FAILED(rv)) {
    return ThrowMethodFailedWithDetails<true>(cx, rv, "XMLHttpRequest", "onuploadprogress");
  }
  *vp = JSVAL_VOID;
  return true;
}

static JSBool
_AddProperty(JSContext* cx, JSObject* obj, jsid id, jsval* vp)
{

  MOZ_ASSERT(js::GetObjectJSClass(obj) == Class.ToJSClass());
  nsXMLHttpRequest* self = UnwrapDOMObject<nsXMLHttpRequest>(obj, Class.ToJSClass());

  JSCompartment* compartment = js::GetObjectCompartment(obj);
  xpc::CompartmentPrivate* priv =
    static_cast<xpc::CompartmentPrivate*>(JS_GetCompartmentPrivate(compartment));
  if (!priv->RegisterDOMExpandoObject(obj)) {
    return false;
  }
  self->SetPreservingWrapper(true);
  return true;
}

static nsISupports*
NativeToSupports(nsXMLHttpRequest* aNative)
{
  return static_cast<nsDOMEventTargetHelper*>(
    static_cast<nsXHREventTarget*>(
      aNative));
}

static void
_Finalize(JSFreeOp* fop, JSObject* obj)
{

  MOZ_ASSERT(js::GetObjectJSClass(obj) == Class.ToJSClass());
  nsXMLHttpRequest* self = UnwrapDOMObject<nsXMLHttpRequest>(obj, Class.ToJSClass());

  self->ClearWrapper();

  XPCJSRuntime *rt = nsXPConnect::GetRuntimeInstance();
  if (rt) {
    rt->DeferredRelease(NativeToSupports(self));
  } else {
    NS_RELEASE(self);
  }
}

const NativePropertyHooks NativeHooks = { ResolveProperty, EnumerateProperties, &XMLHttpRequestEventTarget::NativeHooks };

DOMJSClass Class = {
  { "XMLHttpRequest",
    JSCLASS_IS_DOMJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(1),
    _AddProperty, /* addProperty */
    JS_PropertyStub,       /* delProperty */
    JS_PropertyStub,       /* getProperty */
    JS_StrictPropertyStub, /* setProperty */
    JS_EnumerateStub,
    JS_ResolveStub,
    JS_ConvertStub,
    _Finalize, /* finalize */
    NULL,                  /* checkAccess */
    NULL,                  /* call */
    NULL,                  /* construct */
    NULL,                  /* hasInstance */
    NULL, /* trace */
    JSCLASS_NO_INTERNAL_MEMBERS
  },
  { id::EventTarget, id::XMLHttpRequestEventTarget, id::XMLHttpRequest },
  -1, true, DOM_OBJECT_SLOT,
  &NativeHooks
};

static JSBool
_Construct(JSContext* cx, unsigned argc, JS::Value* vp)
{

  JSObject* obj = JS_GetGlobalForObject(cx, JSVAL_TO_OBJECT(JS_CALLEE(cx, vp)));

  nsISupports* global;
  xpc_qsSelfRef globalRef;
  {
    nsresult rv;
    JS::Value val = OBJECT_TO_JSVAL(obj);
    rv = xpc_qsUnwrapArg<nsISupports>(cx, val, &global, &globalRef.ptr, &val);
    if (NS_FAILED(rv)) {
      return Throw<true>(cx, NS_ERROR_XPC_BAD_CONVERT_JS);
    }
  }
  nsresult rv = NS_OK;
  nsRefPtr<nsXMLHttpRequest> result;
  result = nsXMLHttpRequest::_Constructor(global, rv);
  if (NS_FAILED(rv)) {
    return ThrowMethodFailedWithDetails<true>(cx, rv, "XMLHttpRequest", "constructor");
  }
  if (WrapNewBindingObject(cx, obj, result, vp)) {
    return true;
  }
  return HandleNewBindingWrappingFailure(cx, obj, result, vp);
}

static JSClass PrototypeClass = {
  "XMLHttpRequest Prototype", 0,
  JS_PropertyStub,       /* addProperty */
  JS_PropertyStub,       /* delProperty */
  JS_PropertyStub,       /* getProperty */
  JS_StrictPropertyStub, /* setProperty */
  JS_EnumerateStub,
  JS_ResolveStub,
  JS_ConvertStub,
  NULL,                  /* finalize */
  NULL,                  /* checkAccess */
  NULL,                  /* call */
  NULL,                  /* construct */
  NULL,                  /* hasInstance */
  NULL,                  /* trace */
  JSCLASS_NO_INTERNAL_MEMBERS
};
static JSFunctionSpec sMethods[] = {
  JS_FN("open", open, 5, JSPROP_ENUMERATE),
  JS_FN("setRequestHeader", setRequestHeader, 2, JSPROP_ENUMERATE),
  JS_FN("send", send, 1, JSPROP_ENUMERATE),
  JS_FN("abort", abort, 0, JSPROP_ENUMERATE),
  JS_FN("getResponseHeader", getResponseHeader, 1, JSPROP_ENUMERATE),
  JS_FN("getAllResponseHeaders", getAllResponseHeaders, 0, JSPROP_ENUMERATE),
  JS_FN("overrideMimeType", overrideMimeType, 1, JSPROP_ENUMERATE),
  JS_FN("sendAsBinary", sendAsBinary, 1, JSPROP_ENUMERATE),
  JS_FN("getInterface", getInterface, 1, JSPROP_ENUMERATE),
  JS_FS_END
};

static jsid sMethods_ids[9] = { JSID_VOID };

static JSPropertySpec sAttributes[] = {
  { "onreadystatechange", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_onreadystatechange, (JSStrictPropertyOp)set_onreadystatechange },
  { "readyState", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_readyState, (JSStrictPropertyOp)NULL },
  { "timeout", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_timeout, (JSStrictPropertyOp)set_timeout },
  { "withCredentials", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_withCredentials, (JSStrictPropertyOp)set_withCredentials },
  { "upload", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_upload, (JSStrictPropertyOp)NULL },
  { "status", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_status, (JSStrictPropertyOp)NULL },
  { "statusText", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_statusText, (JSStrictPropertyOp)NULL },
  { "responseType", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_responseType, (JSStrictPropertyOp)set_responseType },
  { "response", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_response, (JSStrictPropertyOp)NULL },
  { "responseText", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_responseText, (JSStrictPropertyOp)NULL },
  { "responseXML", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_responseXML, (JSStrictPropertyOp)NULL },
  { "multipart", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_multipart, (JSStrictPropertyOp)set_multipart },
  { "mozBackgroundRequest", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_mozBackgroundRequest, (JSStrictPropertyOp)set_mozBackgroundRequest },
  { "onuploadprogress", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_onuploadprogress, (JSStrictPropertyOp)set_onuploadprogress },
  { 0, 0, 0, 0, 0 }
};

static jsid sAttributes_ids[14] = { JSID_VOID };

static JSPropertySpec sChromeAttributes[] = {
  { "onreadystatechange", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_onreadystatechange, (JSStrictPropertyOp)set_onreadystatechange },
  { "readyState", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_readyState, (JSStrictPropertyOp)NULL },
  { "timeout", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_timeout, (JSStrictPropertyOp)set_timeout },
  { "withCredentials", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_withCredentials, (JSStrictPropertyOp)set_withCredentials },
  { "upload", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_upload, (JSStrictPropertyOp)NULL },
  { "status", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_status, (JSStrictPropertyOp)NULL },
  { "statusText", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_statusText, (JSStrictPropertyOp)NULL },
  { "responseType", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_responseType, (JSStrictPropertyOp)set_responseType },
  { "response", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_response, (JSStrictPropertyOp)NULL },
  { "responseText", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_responseText, (JSStrictPropertyOp)NULL },
  { "responseXML", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_responseXML, (JSStrictPropertyOp)NULL },
  { "multipart", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_multipart, (JSStrictPropertyOp)set_multipart },
  { "mozBackgroundRequest", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_mozBackgroundRequest, (JSStrictPropertyOp)set_mozBackgroundRequest },
  { "channel", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_channel, (JSStrictPropertyOp)NULL },
  { "onuploadprogress", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_onuploadprogress, (JSStrictPropertyOp)set_onuploadprogress },
  { 0, 0, 0, 0, 0 }
};

static jsid sChromeAttributes_ids[15] = { JSID_VOID };

static ConstantSpec sConstants[] = {
  { "UNSENT", INT_TO_JSVAL(0) },
  { "OPENED", INT_TO_JSVAL(1) },
  { "HEADERS_RECEIVED", INT_TO_JSVAL(2) },
  { "LOADING", INT_TO_JSVAL(3) },
  { "DONE", INT_TO_JSVAL(4) },
  { 0, JSVAL_VOID }
};

static jsid sConstants_ids[5] = { JSID_VOID };


JSObject*
CreateInterfaceObjects(JSContext* aCx, JSObject* aGlobal, JSObject* aReceiver)
{
  if (sMethods_ids[0] == JSID_VOID &&
      (!InitIds(aCx, sMethods, sMethods_ids) ||
       !InitIds(aCx, sAttributes, sAttributes_ids) ||
       !InitIds(aCx, sChromeAttributes, sChromeAttributes_ids) ||
       !InitIds(aCx, sConstants, sConstants_ids))) {
    sMethods_ids[0] = JSID_VOID;
    return NULL;
  }

  JSObject* parentProto = XMLHttpRequestEventTarget::GetProtoObject(aCx, aGlobal, aReceiver);
  if (!parentProto) {
    return NULL;
  }

  if (xpc::AccessCheck::isChrome(js::GetObjectCompartment(aGlobal))) {
    return bindings::CreateInterfaceObjects(aCx, aGlobal, aReceiver, parentProto,
                                            &PrototypeClass, NULL, _Construct, 0,
                                            sMethods, sChromeAttributes, sConstants, NULL,
                                            "XMLHttpRequest");
  }

  return bindings::CreateInterfaceObjects(aCx, aGlobal, aReceiver, parentProto,
                                          &PrototypeClass, NULL, _Construct, 0,
                                          sMethods, sAttributes, sConstants, NULL,
                                          "XMLHttpRequest");
}

bool
ResolveProperty(JSContext* cx, JSObject* wrapper, jsid id, bool set, JSPropertyDescriptor* desc)
{
  for (size_t i = 0; i < ArrayLength(sMethods_ids); ++i) {
    if (id == sMethods_ids[i]) {
      JSFunction *fun = JS_NewFunctionById(cx, sMethods[i].call, sMethods[i].nargs, 0, wrapper, id);
      if (!fun)
          return false;
      JSObject *funobj = JS_GetFunctionObject(fun);
      desc->value.setObject(*funobj);
      desc->attrs = sMethods[i].flags;
      desc->obj = wrapper;
      desc->setter = nsnull;
      desc->getter = nsnull;
      return true;
    }
  }

  for (size_t i = 0; i < ArrayLength(sChromeAttributes_ids); ++i) {
    if (id == sChromeAttributes_ids[i]) {
      desc->attrs = sChromeAttributes[i].flags;
      desc->obj = wrapper;
      desc->setter = sChromeAttributes[i].setter;
      desc->getter = sChromeAttributes[i].getter;
      return true;
    }
  }

  return true;
}

bool
EnumerateProperties(JS::AutoIdVector& props)
{
  for (size_t i = 0; i < sizeof(sMethods_ids); ++i) {
    if ((sMethods[i].flags & JSPROP_ENUMERATE) &&
        !props.append(sMethods_ids[i])) {
      return false;
    }
  }

  for (size_t i = 0; i < sizeof(sChromeAttributes_ids); ++i) {
    if ((sChromeAttributes[i].flags & JSPROP_ENUMERATE) &&
        !props.append(sChromeAttributes_ids[i])) {
      return false;
    }
  }

  return true;
}

bool
DefineDOMInterface(JSContext* aCx, JSObject* aReceiver, bool* aEnabled)
{
  JSObject* global = JS_GetGlobalForObject(aCx, aReceiver);

  {
    XPCWrappedNativeScope* scope =
      XPCWrappedNativeScope::FindInJSObjectScope(aCx, global);
    if (!scope) {
      return false;
    }

    if (!scope->ParisBindingsEnabled()) {
      *aEnabled = false;
      return false;
    }
  }

  *aEnabled = true;
  return !!GetProtoObject(aCx, global, aReceiver);
}

JSObject*
Wrap(JSContext* aCx, JSObject* aScope, nsXMLHttpRequest* aObject, bool* aTriedToWrap)
{

  *aTriedToWrap = true;

  JSObject* parent = bindings::WrapNativeParent(aCx, aScope, aObject->GetParentObject());
  if (!parent) {
    return NULL;
  }

  JSAutoEnterCompartment ac;
  if (js::GetGlobalForObjectCrossCompartment(parent) != aScope) {
    if (!ac.enter(aCx, parent)) {
      return NULL;
    }
  }

  JSObject* global = JS_GetGlobalForObject(aCx, parent);

  {
    XPCWrappedNativeScope* scope =
      XPCWrappedNativeScope::FindInJSObjectScope(aCx, global);
    if (!scope) {
      return NULL;
    }

    if (!scope->ParisBindingsEnabled()) {
      aObject->ClearIsDOMBinding();
      *aTriedToWrap = false;
      return NULL;
    }
  }

  JSObject* proto = GetProtoObject(aCx, global, global);
  if (!proto) {
    return NULL;
  }

  JSObject* obj = JS_NewObject(aCx, &Class.mBase, proto, parent);
  if (!obj) {
    return NULL;
  }

  js::SetReservedSlot(obj, DOM_OBJECT_SLOT, PRIVATE_TO_JSVAL(aObject));
  NS_ADDREF(aObject);

  aObject->SetWrapper(obj);

  return obj;
}

} // namespace XMLHttpRequest

namespace XMLHttpRequest_workers {

static JSBool
open(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  mozilla::dom::workers::XMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest_workers>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<false>(cx, rv);
    }
  }

  if (argc < 2) {
    return Throw<false>(cx, NS_ERROR_XPC_NOT_ENOUGH_ARGS);
  }

  JS::Value* argv = JS_ARGV(cx, vp);

  xpc_qsDOMString arg0(cx, argv[0], &argv[0],
                       xpc_qsDOMString::eDefaultNullBehavior,
                       xpc_qsDOMString::eDefaultUndefinedBehavior);
  if (!arg0.IsValid()) {
    return false;
  }

  xpc_qsDOMString arg1(cx, argv[1], &argv[1],
                       xpc_qsDOMString::eDefaultNullBehavior,
                       xpc_qsDOMString::eDefaultUndefinedBehavior);
  if (!arg1.IsValid()) {
    return false;
  }

  JSBool arg2_jstype;
  bool arg2;
  if (JS_ValueToBoolean(cx, (2 < argc ? argv[2] : JSVAL_TRUE), &arg2_jstype)) {
    arg2 = ((bool)arg2_jstype);
  } else {
    return false;
  }

  xpc_qsDOMString arg3(cx, (3 < argc ? argv[3] : JSVAL_VOID), (3 < argc ? &argv[3] : NULL),
                       xpc_qsDOMString::eNull,
                       xpc_qsDOMString::eNull);
  if (!arg3.IsValid()) {
    return false;
  }

  xpc_qsDOMString arg4(cx, (4 < argc ? argv[4] : JSVAL_VOID), (4 < argc ? &argv[4] : NULL),
                       xpc_qsDOMString::eNull,
                       xpc_qsDOMString::eNull);
  if (!arg4.IsValid()) {
    return false;
  }

  nsresult rv = NS_OK;
  self->Open(arg0, arg1, arg2, arg3, arg4, rv);
  if (NS_FAILED(rv)) {
    return ThrowMethodFailedWithDetails<false>(cx, rv, "XMLHttpRequest", "open");
  }
  *vp = JSVAL_VOID;
  return true;
}

static JSBool
setRequestHeader(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  mozilla::dom::workers::XMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest_workers>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<false>(cx, rv);
    }
  }

  if (argc < 2) {
    return Throw<false>(cx, NS_ERROR_XPC_NOT_ENOUGH_ARGS);
  }

  JS::Value* argv = JS_ARGV(cx, vp);

  xpc_qsDOMString arg0(cx, argv[0], &argv[0],
                       xpc_qsDOMString::eDefaultNullBehavior,
                       xpc_qsDOMString::eDefaultUndefinedBehavior);
  if (!arg0.IsValid()) {
    return false;
  }

  xpc_qsDOMString arg1(cx, argv[1], &argv[1],
                       xpc_qsDOMString::eDefaultNullBehavior,
                       xpc_qsDOMString::eDefaultUndefinedBehavior);
  if (!arg1.IsValid()) {
    return false;
  }

  nsresult rv = NS_OK;
  self->SetRequestHeader(arg0, arg1, rv);
  if (NS_FAILED(rv)) {
    return ThrowMethodFailedWithDetails<false>(cx, rv, "XMLHttpRequest", "setRequestHeader");
  }
  *vp = JSVAL_VOID;
  return true;
}

static JSBool
send(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  mozilla::dom::workers::XMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest_workers>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<false>(cx, rv);
    }
  }

  unsigned argcount = NS_MIN(argc, 1u);
  switch (argcount) {
    case 0: {
      nsresult rv = NS_OK;
      self->Send(rv);
      if (NS_FAILED(rv)) {
        return ThrowMethodFailedWithDetails<false>(cx, rv, "XMLHttpRequest", "send");
      }
      *vp = JSVAL_VOID;
      return true;
      break;
    }
    case 1: {
      JS::Value* argv_start = JS_ARGV(cx, vp);
      if (argv_start[0].isNullOrUndefined()) {

        JS::Value* argv = JS_ARGV(cx, vp);

        xpc_qsDOMString arg0(cx, argv[0], &argv[0],
                             xpc_qsDOMString::eNull,
                             xpc_qsDOMString::eNull);
        if (!arg0.IsValid()) {
          return false;
        }

        nsresult rv = NS_OK;
        self->Send(arg0, rv);
        if (NS_FAILED(rv)) {
          return ThrowMethodFailedWithDetails<false>(cx, rv, "XMLHttpRequest", "send");
        }
        *vp = JSVAL_VOID;
        return true;
      }
      if (argv_start[0].isObject() && JS_IsArrayBufferObject(&argv_start[0].toObject(), cx)) {

        JS::Value* argv = JS_ARGV(cx, vp);

        JSObject* arg0;
        if (argv[0].isObject() && JS_IsArrayBufferObject(&argv[0].toObject(), cx)) {
          arg0 = &argv[0].toObject();
        } else {
          return Throw<false>(cx, NS_ERROR_XPC_BAD_CONVERT_JS);
        }
        nsresult rv = NS_OK;
        self->Send(arg0, rv);
        if (NS_FAILED(rv)) {
          return ThrowMethodFailedWithDetails<false>(cx, rv, "XMLHttpRequest", "send");
        }
        *vp = JSVAL_VOID;
        return true;
      }
      if (argv_start[0].isObject() &&
          IsPlatformObject(cx, &argv_start[0].toObject())) {
        do {
          JSObject* arg0;

            arg0 = &argv_start[0].toObject();
            MOZ_ASSERT(arg0);

          nsresult rv = NS_OK;
          self->Send(arg0, rv);
          if (NS_FAILED(rv)) {
            return ThrowMethodFailedWithDetails<false>(cx, rv, "XMLHttpRequest", "send");
          }
          *vp = JSVAL_VOID;
          return true;
        } while (0);
        do {
          JSObject* arg0;

            arg0 = &argv_start[0].toObject();
            MOZ_ASSERT(arg0);

          nsresult rv = NS_OK;
          self->Send(arg0, rv);
          if (NS_FAILED(rv)) {
            return ThrowMethodFailedWithDetails<false>(cx, rv, "XMLHttpRequest", "send");
          }
          *vp = JSVAL_VOID;
          return true;
        } while (0);
        do {
          JSObject* arg0;

            arg0 = &argv_start[0].toObject();
            MOZ_ASSERT(arg0);

          nsresult rv = NS_OK;
          self->Send(arg0, rv);
          if (NS_FAILED(rv)) {
            return ThrowMethodFailedWithDetails<false>(cx, rv, "XMLHttpRequest", "send");
          }
          *vp = JSVAL_VOID;
          return true;
        } while (0);
        do {
          JSObject* arg0;

            arg0 = &argv_start[0].toObject();
            MOZ_ASSERT(arg0);

          nsresult rv = NS_OK;
          self->Send(arg0, rv);
          if (NS_FAILED(rv)) {
            return ThrowMethodFailedWithDetails<false>(cx, rv, "XMLHttpRequest", "send");
          }
          *vp = JSVAL_VOID;
          return true;
        } while (0);
      }

      JS::Value* argv = JS_ARGV(cx, vp);

      xpc_qsDOMString arg0(cx, argv[0], &argv[0],
                           xpc_qsDOMString::eNull,
                           xpc_qsDOMString::eNull);
      if (!arg0.IsValid()) {
        return false;
      }

      nsresult rv = NS_OK;
      self->Send(arg0, rv);
      if (NS_FAILED(rv)) {
        return ThrowMethodFailedWithDetails<false>(cx, rv, "XMLHttpRequest", "send");
      }
      *vp = JSVAL_VOID;
      return true;
      break;
    }
    default: {
      return Throw<false>(cx, NS_ERROR_XPC_NOT_ENOUGH_ARGS);
      break;
    }
  }
  MOZ_NOT_REACHED("We have an always-returning default case");
  return false;
}

static JSBool
abort(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  mozilla::dom::workers::XMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest_workers>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<false>(cx, rv);
    }
  }
  nsresult rv = NS_OK;
  self->Abort(rv);
  if (NS_FAILED(rv)) {
    return ThrowMethodFailedWithDetails<false>(cx, rv, "XMLHttpRequest", "abort");
  }
  *vp = JSVAL_VOID;
  return true;
}

static JSBool
getResponseHeader(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  mozilla::dom::workers::XMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest_workers>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<false>(cx, rv);
    }
  }

  if (argc < 1) {
    return Throw<false>(cx, NS_ERROR_XPC_NOT_ENOUGH_ARGS);
  }

  JS::Value* argv = JS_ARGV(cx, vp);

  xpc_qsDOMString arg0(cx, argv[0], &argv[0],
                       xpc_qsDOMString::eDefaultNullBehavior,
                       xpc_qsDOMString::eDefaultUndefinedBehavior);
  if (!arg0.IsValid()) {
    return false;
  }

  nsresult rv = NS_OK;
  nsString result;
  self->GetResponseHeader(arg0, result, rv);
  if (NS_FAILED(rv)) {
    return ThrowMethodFailedWithDetails<false>(cx, rv, "XMLHttpRequest", "getResponseHeader");
  }
  return xpc::StringToJsval(cx, result, vp);
}

static JSBool
getAllResponseHeaders(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  mozilla::dom::workers::XMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest_workers>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<false>(cx, rv);
    }
  }
  nsresult rv = NS_OK;
  nsString result;
  self->GetAllResponseHeaders(result, rv);
  if (NS_FAILED(rv)) {
    return ThrowMethodFailedWithDetails<false>(cx, rv, "XMLHttpRequest", "getAllResponseHeaders");
  }
  return xpc::NonVoidStringToJsval(cx, result, vp);
}

static JSBool
overrideMimeType(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  mozilla::dom::workers::XMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest_workers>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<false>(cx, rv);
    }
  }

  if (argc < 1) {
    return Throw<false>(cx, NS_ERROR_XPC_NOT_ENOUGH_ARGS);
  }

  JS::Value* argv = JS_ARGV(cx, vp);

  xpc_qsDOMString arg0(cx, argv[0], &argv[0],
                       xpc_qsDOMString::eDefaultNullBehavior,
                       xpc_qsDOMString::eDefaultUndefinedBehavior);
  if (!arg0.IsValid()) {
    return false;
  }

  nsresult rv = NS_OK;
  self->OverrideMimeType(arg0, rv);
  if (NS_FAILED(rv)) {
    return ThrowMethodFailedWithDetails<false>(cx, rv, "XMLHttpRequest", "overrideMimeType");
  }
  *vp = JSVAL_VOID;
  return true;
}

static JSBool
sendAsBinary(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  mozilla::dom::workers::XMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest_workers>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<false>(cx, rv);
    }
  }

  if (argc < 1) {
    return Throw<false>(cx, NS_ERROR_XPC_NOT_ENOUGH_ARGS);
  }

  JS::Value* argv = JS_ARGV(cx, vp);

  xpc_qsDOMString arg0(cx, argv[0], &argv[0],
                       xpc_qsDOMString::eDefaultNullBehavior,
                       xpc_qsDOMString::eDefaultUndefinedBehavior);
  if (!arg0.IsValid()) {
    return false;
  }

  nsresult rv = NS_OK;
  self->SendAsBinary(arg0, rv);
  if (NS_FAILED(rv)) {
    return ThrowMethodFailedWithDetails<false>(cx, rv, "XMLHttpRequest", "sendAsBinary");
  }
  *vp = JSVAL_VOID;
  return true;
}

static JSBool
getInterface(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  mozilla::dom::workers::XMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest_workers>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<false>(cx, rv);
    }
  }

  if (argc < 1) {
    return Throw<false>(cx, NS_ERROR_XPC_NOT_ENOUGH_ARGS);
  }

  JS::Value* argv = JS_ARGV(cx, vp);

  JSObject* arg0;
  if (argv[0].isObject()) {
    arg0 = &argv[0].toObject();
    MOZ_ASSERT(arg0);
  } else {
    return Throw<false>(cx, NS_ERROR_XPC_BAD_CONVERT_JS);
  }

  nsresult rv = NS_OK;
  JS::Value result;
  result = self->GetInterface(arg0, rv);
  if (NS_FAILED(rv)) {
    return ThrowMethodFailedWithDetails<false>(cx, rv, "XMLHttpRequest", "getInterface");
  }
  *vp = result;

  return JS_WrapValue(cx, vp);
}

static JSBool
get_onreadystatechange(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  mozilla::dom::workers::XMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest_workers>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<false>(cx, rv);
    }
  }
  nsresult rv = NS_OK;
  JSObject* result;
  result = self->GetOnreadystatechange(rv);
  if (NS_FAILED(rv)) {
    return ThrowMethodFailedWithDetails<false>(cx, rv, "XMLHttpRequest", "onreadystatechange");
  }
  *vp = JS::ObjectOrNullValue(result);
  return JS_WrapValue(cx, vp);
}

static JSBool
get_readyState(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  mozilla::dom::workers::XMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest_workers>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<false>(cx, rv);
    }
  }
  uint16_t result;
  result = self->GetReadyState();
  *vp = INT_TO_JSVAL(int32_t(result));
  return true;
}

static JSBool
get_timeout(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  mozilla::dom::workers::XMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest_workers>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<false>(cx, rv);
    }
  }
  nsresult rv = NS_OK;
  uint32_t result;
  result = self->GetTimeout(rv);
  if (NS_FAILED(rv)) {
    return ThrowMethodFailedWithDetails<false>(cx, rv, "XMLHttpRequest", "timeout");
  }
  *vp = UINT_TO_JSVAL(result);
  return true;
}

static JSBool
get_withCredentials(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  mozilla::dom::workers::XMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest_workers>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<false>(cx, rv);
    }
  }
  nsresult rv = NS_OK;
  bool result;
  result = self->GetWithCredentials(rv);
  if (NS_FAILED(rv)) {
    return ThrowMethodFailedWithDetails<false>(cx, rv, "XMLHttpRequest", "withCredentials");
  }
  *vp = BOOLEAN_TO_JSVAL(result);
  return true;
}

static JSBool
get_upload(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  mozilla::dom::workers::XMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest_workers>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<false>(cx, rv);
    }
  }
  nsresult rv = NS_OK;
  mozilla::dom::workers::XMLHttpRequestUpload* result;
  result = self->GetUpload(rv);
  if (NS_FAILED(rv)) {
    return ThrowMethodFailedWithDetails<false>(cx, rv, "XMLHttpRequest", "upload");
  }
  if (WrapNewBindingObject(cx, obj, result, vp)) {
    return true;
  }
  MOZ_ASSERT(JS_IsExceptionPending(cx));
  return false;
}

static JSBool
get_status(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  mozilla::dom::workers::XMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest_workers>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<false>(cx, rv);
    }
  }
  nsresult rv = NS_OK;
  uint16_t result;
  result = self->GetStatus(rv);
  if (NS_FAILED(rv)) {
    return ThrowMethodFailedWithDetails<false>(cx, rv, "XMLHttpRequest", "status");
  }
  *vp = INT_TO_JSVAL(int32_t(result));
  return true;
}

static JSBool
get_statusText(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  mozilla::dom::workers::XMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest_workers>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<false>(cx, rv);
    }
  }
  nsString result;
  self->GetStatusText(result);
  return xpc::NonVoidStringToJsval(cx, result, vp);
}

static JSBool
get_responseType(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  mozilla::dom::workers::XMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest_workers>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<false>(cx, rv);
    }
  }
  nsresult rv = NS_OK;
  XMLHttpRequestResponseType::value result;
  result = self->GetResponseType(rv);
  if (NS_FAILED(rv)) {
    return ThrowMethodFailedWithDetails<false>(cx, rv, "XMLHttpRequest", "responseType");
  }
  MOZ_ASSERT(uint32_t(result) < ArrayLength(XMLHttpRequestResponseType::strings));
  JSString* result_str = JS_NewStringCopyN(cx, XMLHttpRequestResponseType::strings[uint32_t(result)].value, XMLHttpRequestResponseType::strings[uint32_t(result)].length);
  if (!result_str) {
    return false;
  }
  *vp = JS::StringValue(result_str);
  return true;
}

static JSBool
get_response(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  mozilla::dom::workers::XMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest_workers>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<false>(cx, rv);
    }
  }
  nsresult rv = NS_OK;
  JS::Value result;
  result = self->GetResponse(rv);
  if (NS_FAILED(rv)) {
    return ThrowMethodFailedWithDetails<false>(cx, rv, "XMLHttpRequest", "response");
  }
  *vp = result;

  return JS_WrapValue(cx, vp);
}

static JSBool
get_responseText(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  mozilla::dom::workers::XMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest_workers>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<false>(cx, rv);
    }
  }
  nsresult rv = NS_OK;
  nsString result;
  self->GetResponseText(result, rv);
  if (NS_FAILED(rv)) {
    return ThrowMethodFailedWithDetails<false>(cx, rv, "XMLHttpRequest", "responseText");
  }
  return xpc::StringToJsval(cx, result, vp);
}

static JSBool
get_responseXML(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  mozilla::dom::workers::XMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest_workers>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<false>(cx, rv);
    }
  }
  nsresult rv = NS_OK;
  JSObject* result;
  result = self->GetResponseXML(rv);
  if (NS_FAILED(rv)) {
    return ThrowMethodFailedWithDetails<false>(cx, rv, "XMLHttpRequest", "responseXML");
  }
  if (!result) {
    *vp = JSVAL_NULL;
    return true;
  }
  return WrapObject(cx, obj, result, vp);
}

static JSBool
get_multipart(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  mozilla::dom::workers::XMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest_workers>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<false>(cx, rv);
    }
  }
  nsresult rv = NS_OK;
  bool result;
  result = self->GetMultipart(rv);
  if (NS_FAILED(rv)) {
    return ThrowMethodFailedWithDetails<false>(cx, rv, "XMLHttpRequest", "multipart");
  }
  *vp = BOOLEAN_TO_JSVAL(result);
  return true;
}

static JSBool
get_mozBackgroundRequest(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  mozilla::dom::workers::XMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest_workers>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<false>(cx, rv);
    }
  }
  nsresult rv = NS_OK;
  bool result;
  result = self->GetMozBackgroundRequest(rv);
  if (NS_FAILED(rv)) {
    return ThrowMethodFailedWithDetails<false>(cx, rv, "XMLHttpRequest", "mozBackgroundRequest");
  }
  *vp = BOOLEAN_TO_JSVAL(result);
  return true;
}

static JSBool
get_channel(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  mozilla::dom::workers::XMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest_workers>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<false>(cx, rv);
    }
  }
  nsresult rv = NS_OK;
  JSObject* result;
  result = self->GetChannel(rv);
  if (NS_FAILED(rv)) {
    return ThrowMethodFailedWithDetails<false>(cx, rv, "XMLHttpRequest", "channel");
  }
  return WrapObject(cx, obj, result, vp);
}

static JSBool
get_onuploadprogress(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  mozilla::dom::workers::XMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest_workers>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<false>(cx, rv);
    }
  }
  nsresult rv = NS_OK;
  JSObject* result;
  result = self->GetOnuploadprogress(rv);
  if (NS_FAILED(rv)) {
    return ThrowMethodFailedWithDetails<false>(cx, rv, "XMLHttpRequest", "onuploadprogress");
  }
  *vp = JS::ObjectOrNullValue(result);
  return JS_WrapValue(cx, vp);
}

static JSBool
set_onreadystatechange(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  mozilla::dom::workers::XMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest_workers>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<false>(cx, rv);
    }
  }

  JS::Value* argv = JS_ARGV(cx, vp);
  jsval undef = JS::UndefinedValue();
  if (argc == 0) {
    argv = &undef;
    argc = 1;
  }
  JSObject* arg0;
  if (argv[0].isObject() && JS_ObjectIsCallable(cx, &argv[0].toObject())) {
    arg0 = &argv[0].toObject();
  } else {
    arg0 = NULL;
  }

  nsresult rv = NS_OK;
  self->SetOnreadystatechange(arg0, rv);
  if (NS_FAILED(rv)) {
    return ThrowMethodFailedWithDetails<false>(cx, rv, "XMLHttpRequest", "onreadystatechange");
  }
  *vp = JSVAL_VOID;
  return true;
}

static JSBool
set_timeout(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  mozilla::dom::workers::XMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest_workers>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<false>(cx, rv);
    }
  }

  JS::Value* argv = JS_ARGV(cx, vp);
  jsval undef = JS::UndefinedValue();
  if (argc == 0) {
    argv = &undef;
    argc = 1;
  }
  int32_t arg0_jstype;
  uint32_t arg0;
  if (JS::ToInt32(cx, argv[0], &arg0_jstype)) {
    arg0 = ((uint32_t)arg0_jstype);
  } else {
    return false;
  }

  nsresult rv = NS_OK;
  self->SetTimeout(arg0, rv);
  if (NS_FAILED(rv)) {
    return ThrowMethodFailedWithDetails<false>(cx, rv, "XMLHttpRequest", "timeout");
  }
  *vp = JSVAL_VOID;
  return true;
}

static JSBool
set_withCredentials(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  mozilla::dom::workers::XMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest_workers>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<false>(cx, rv);
    }
  }

  JS::Value* argv = JS_ARGV(cx, vp);
  jsval undef = JS::UndefinedValue();
  if (argc == 0) {
    argv = &undef;
    argc = 1;
  }
  JSBool arg0_jstype;
  bool arg0;
  if (JS_ValueToBoolean(cx, argv[0], &arg0_jstype)) {
    arg0 = ((bool)arg0_jstype);
  } else {
    return false;
  }

  nsresult rv = NS_OK;
  self->SetWithCredentials(arg0, rv);
  if (NS_FAILED(rv)) {
    return ThrowMethodFailedWithDetails<false>(cx, rv, "XMLHttpRequest", "withCredentials");
  }
  *vp = JSVAL_VOID;
  return true;
}

static JSBool
set_responseType(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  mozilla::dom::workers::XMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest_workers>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<false>(cx, rv);
    }
  }

  JS::Value* argv = JS_ARGV(cx, vp);
  jsval undef = JS::UndefinedValue();
  if (argc == 0) {
    argv = &undef;
    argc = 1;
  }
  XMLHttpRequestResponseType::value arg0;
  {
    bool ok;
    int index = FindEnumStringIndex(cx, argv[0], XMLHttpRequestResponseType::strings, &ok);
    if (!ok) {
      return false;
    }
    if (index < 0) {
      return true;
    }
    arg0 = static_cast<XMLHttpRequestResponseType::value>(index);
  }
  nsresult rv = NS_OK;
  self->SetResponseType(arg0, rv);
  if (NS_FAILED(rv)) {
    return ThrowMethodFailedWithDetails<false>(cx, rv, "XMLHttpRequest", "responseType");
  }
  *vp = JSVAL_VOID;
  return true;
}

static JSBool
set_multipart(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  mozilla::dom::workers::XMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest_workers>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<false>(cx, rv);
    }
  }

  JS::Value* argv = JS_ARGV(cx, vp);
  jsval undef = JS::UndefinedValue();
  if (argc == 0) {
    argv = &undef;
    argc = 1;
  }
  JSBool arg0_jstype;
  bool arg0;
  if (JS_ValueToBoolean(cx, argv[0], &arg0_jstype)) {
    arg0 = ((bool)arg0_jstype);
  } else {
    return false;
  }

  nsresult rv = NS_OK;
  self->SetMultipart(arg0, rv);
  if (NS_FAILED(rv)) {
    return ThrowMethodFailedWithDetails<false>(cx, rv, "XMLHttpRequest", "multipart");
  }
  *vp = JSVAL_VOID;
  return true;
}

static JSBool
set_mozBackgroundRequest(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  mozilla::dom::workers::XMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest_workers>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<false>(cx, rv);
    }
  }

  JS::Value* argv = JS_ARGV(cx, vp);
  jsval undef = JS::UndefinedValue();
  if (argc == 0) {
    argv = &undef;
    argc = 1;
  }
  JSBool arg0_jstype;
  bool arg0;
  if (JS_ValueToBoolean(cx, argv[0], &arg0_jstype)) {
    arg0 = ((bool)arg0_jstype);
  } else {
    return false;
  }

  nsresult rv = NS_OK;
  self->SetMozBackgroundRequest(arg0, rv);
  if (NS_FAILED(rv)) {
    return ThrowMethodFailedWithDetails<false>(cx, rv, "XMLHttpRequest", "mozBackgroundRequest");
  }
  *vp = JSVAL_VOID;
  return true;
}

static JSBool
set_onuploadprogress(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JSObject* obj = JS_THIS_OBJECT(cx, vp);
  if (!obj) {
    return false;
  }

  mozilla::dom::workers::XMLHttpRequest* self;
  {
    nsresult rv = UnwrapObject<id::XMLHttpRequest_workers>(cx, obj, &self);
    if (NS_FAILED(rv)) {
      return Throw<false>(cx, rv);
    }
  }

  JS::Value* argv = JS_ARGV(cx, vp);
  jsval undef = JS::UndefinedValue();
  if (argc == 0) {
    argv = &undef;
    argc = 1;
  }
  JSObject* arg0;
  if (argv[0].isObject() && JS_ObjectIsCallable(cx, &argv[0].toObject())) {
    arg0 = &argv[0].toObject();
  } else {
    arg0 = NULL;
  }

  nsresult rv = NS_OK;
  self->SetOnuploadprogress(arg0, rv);
  if (NS_FAILED(rv)) {
    return ThrowMethodFailedWithDetails<false>(cx, rv, "XMLHttpRequest", "onuploadprogress");
  }
  *vp = JSVAL_VOID;
  return true;
}

static void
_Finalize(JSFreeOp* fop, JSObject* obj)
{

  MOZ_ASSERT(js::GetObjectJSClass(obj) == Class.ToJSClass());
  mozilla::dom::workers::XMLHttpRequest* self = UnwrapDOMObject<mozilla::dom::workers::XMLHttpRequest>(obj, Class.ToJSClass());
  if (self) {
    self->_Finalize(fop);
  }
}

static void
_Trace(JSTracer* trc, JSObject* obj)
{

  MOZ_ASSERT(js::GetObjectJSClass(obj) == Class.ToJSClass());
  mozilla::dom::workers::XMLHttpRequest* self = UnwrapDOMObject<mozilla::dom::workers::XMLHttpRequest>(obj, Class.ToJSClass());
  if (self) {
    self->_Trace(trc);
  }
}

const NativePropertyHooks NativeHooks = { ResolveProperty, EnumerateProperties, &XMLHttpRequestEventTarget::NativeHooks };

DOMJSClass Class = {
  { "XMLHttpRequest",
    JSCLASS_IS_DOMJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(1),
    JS_PropertyStub, /* addProperty */
    JS_PropertyStub,       /* delProperty */
    JS_PropertyStub,       /* getProperty */
    JS_StrictPropertyStub, /* setProperty */
    JS_EnumerateStub,
    JS_ResolveStub,
    JS_ConvertStub,
    _Finalize, /* finalize */
    NULL,                  /* checkAccess */
    NULL,                  /* call */
    NULL,                  /* construct */
    NULL,                  /* hasInstance */
    _Trace, /* trace */
    JSCLASS_NO_INTERNAL_MEMBERS
  },
  { id::EventTarget_workers, id::XMLHttpRequestEventTarget_workers, id::XMLHttpRequest_workers },
  -1, false, DOM_OBJECT_SLOT,
  &NativeHooks
};

static JSBool
_Construct(JSContext* cx, unsigned argc, JS::Value* vp)
{

  JSObject* obj = JS_GetGlobalForObject(cx, JSVAL_TO_OBJECT(JS_CALLEE(cx, vp)));
  nsresult rv = NS_OK;
  mozilla::dom::workers::XMLHttpRequest* result;
  result = mozilla::dom::workers::XMLHttpRequest::_Constructor(cx, obj, rv);
  if (NS_FAILED(rv)) {
    return ThrowMethodFailedWithDetails<false>(cx, rv, "XMLHttpRequest", "constructor");
  }
  if (WrapNewBindingObject(cx, obj, result, vp)) {
    return true;
  }
  MOZ_ASSERT(JS_IsExceptionPending(cx));
  return false;
}

static JSClass PrototypeClass = {
  "XMLHttpRequest Prototype", 0,
  JS_PropertyStub,       /* addProperty */
  JS_PropertyStub,       /* delProperty */
  JS_PropertyStub,       /* getProperty */
  JS_StrictPropertyStub, /* setProperty */
  JS_EnumerateStub,
  JS_ResolveStub,
  JS_ConvertStub,
  NULL,                  /* finalize */
  NULL,                  /* checkAccess */
  NULL,                  /* call */
  NULL,                  /* construct */
  NULL,                  /* hasInstance */
  NULL,                  /* trace */
  JSCLASS_NO_INTERNAL_MEMBERS
};
static JSFunctionSpec sMethods[] = {
  JS_FN("open", open, 5, JSPROP_ENUMERATE),
  JS_FN("setRequestHeader", setRequestHeader, 2, JSPROP_ENUMERATE),
  JS_FN("send", send, 1, JSPROP_ENUMERATE),
  JS_FN("abort", abort, 0, JSPROP_ENUMERATE),
  JS_FN("getResponseHeader", getResponseHeader, 1, JSPROP_ENUMERATE),
  JS_FN("getAllResponseHeaders", getAllResponseHeaders, 0, JSPROP_ENUMERATE),
  JS_FN("overrideMimeType", overrideMimeType, 1, JSPROP_ENUMERATE),
  JS_FN("sendAsBinary", sendAsBinary, 1, JSPROP_ENUMERATE),
  JS_FN("getInterface", getInterface, 1, JSPROP_ENUMERATE),
  JS_FS_END
};

static jsid sMethods_ids[9] = { JSID_VOID };

static JSPropertySpec sAttributes[] = {
  { "onreadystatechange", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_onreadystatechange, (JSStrictPropertyOp)set_onreadystatechange },
  { "readyState", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_readyState, (JSStrictPropertyOp)NULL },
  { "timeout", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_timeout, (JSStrictPropertyOp)set_timeout },
  { "withCredentials", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_withCredentials, (JSStrictPropertyOp)set_withCredentials },
  { "upload", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_upload, (JSStrictPropertyOp)NULL },
  { "status", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_status, (JSStrictPropertyOp)NULL },
  { "statusText", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_statusText, (JSStrictPropertyOp)NULL },
  { "responseType", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_responseType, (JSStrictPropertyOp)set_responseType },
  { "response", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_response, (JSStrictPropertyOp)NULL },
  { "responseText", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_responseText, (JSStrictPropertyOp)NULL },
  { "responseXML", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_responseXML, (JSStrictPropertyOp)NULL },
  { "multipart", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_multipart, (JSStrictPropertyOp)set_multipart },
  { "mozBackgroundRequest", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_mozBackgroundRequest, (JSStrictPropertyOp)set_mozBackgroundRequest },
  { "onuploadprogress", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_onuploadprogress, (JSStrictPropertyOp)set_onuploadprogress },
  { 0, 0, 0, 0, 0 }
};

static jsid sAttributes_ids[14] = { JSID_VOID };

static JSPropertySpec sChromeAttributes[] = {
  { "onreadystatechange", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_onreadystatechange, (JSStrictPropertyOp)set_onreadystatechange },
  { "readyState", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_readyState, (JSStrictPropertyOp)NULL },
  { "timeout", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_timeout, (JSStrictPropertyOp)set_timeout },
  { "withCredentials", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_withCredentials, (JSStrictPropertyOp)set_withCredentials },
  { "upload", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_upload, (JSStrictPropertyOp)NULL },
  { "status", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_status, (JSStrictPropertyOp)NULL },
  { "statusText", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_statusText, (JSStrictPropertyOp)NULL },
  { "responseType", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_responseType, (JSStrictPropertyOp)set_responseType },
  { "response", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_response, (JSStrictPropertyOp)NULL },
  { "responseText", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_responseText, (JSStrictPropertyOp)NULL },
  { "responseXML", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_responseXML, (JSStrictPropertyOp)NULL },
  { "multipart", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_multipart, (JSStrictPropertyOp)set_multipart },
  { "mozBackgroundRequest", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_mozBackgroundRequest, (JSStrictPropertyOp)set_mozBackgroundRequest },
  { "channel", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_channel, (JSStrictPropertyOp)NULL },
  { "onuploadprogress", 0, JSPROP_NATIVE_ACCESSORS | JSPROP_SHARED | JSPROP_ENUMERATE, (JSPropertyOp)get_onuploadprogress, (JSStrictPropertyOp)set_onuploadprogress },
  { 0, 0, 0, 0, 0 }
};

static jsid sChromeAttributes_ids[15] = { JSID_VOID };

static ConstantSpec sConstants[] = {
  { "UNSENT", INT_TO_JSVAL(0) },
  { "OPENED", INT_TO_JSVAL(1) },
  { "HEADERS_RECEIVED", INT_TO_JSVAL(2) },
  { "LOADING", INT_TO_JSVAL(3) },
  { "DONE", INT_TO_JSVAL(4) },
  { 0, JSVAL_VOID }
};

static jsid sConstants_ids[5] = { JSID_VOID };


JSObject*
CreateInterfaceObjects(JSContext* aCx, JSObject* aGlobal, JSObject* aReceiver)
{
  if (sMethods_ids[0] == JSID_VOID &&
      (!InitIds(aCx, sMethods, sMethods_ids) ||
       !InitIds(aCx, sAttributes, sAttributes_ids) ||
       !InitIds(aCx, sConstants, sConstants_ids))) {
    sMethods_ids[0] = JSID_VOID;
    return NULL;
  }

  JSObject* parentProto = XMLHttpRequestEventTarget_workers::GetProtoObject(aCx, aGlobal, aReceiver);
  if (!parentProto) {
    return NULL;
  }

  if (mozilla::dom::workers::GetWorkerPrivateFromContext(aCx)->IsChromeWorker()) {
    return bindings::CreateInterfaceObjects(aCx, aGlobal, aReceiver, parentProto,
                                            &PrototypeClass, NULL, _Construct, 0,
                                            sMethods, sChromeAttributes, sConstants, NULL,
                                            "XMLHttpRequest");
  }

  return bindings::CreateInterfaceObjects(aCx, aGlobal, aReceiver, parentProto,
                                          &PrototypeClass, NULL, _Construct, 0,
                                          sMethods, sAttributes, sConstants, NULL,
                                          "XMLHttpRequest");
}

bool
ResolveProperty(JSContext* cx, JSObject* wrapper, jsid id, bool set, JSPropertyDescriptor* desc)
{
  for (size_t i = 0; i < ArrayLength(sMethods_ids); ++i) {
    if (id == sMethods_ids[i]) {
      JSFunction *fun = JS_NewFunctionById(cx, sMethods[i].call, sMethods[i].nargs, 0, wrapper, id);
      if (!fun)
          return false;
      JSObject *funobj = JS_GetFunctionObject(fun);
      desc->value.setObject(*funobj);
      desc->attrs = sMethods[i].flags;
      desc->obj = wrapper;
      desc->setter = nsnull;
      desc->getter = nsnull;
      return true;
    }
  }

  for (size_t i = 0; i < ArrayLength(sChromeAttributes_ids); ++i) {
    if (id == sChromeAttributes_ids[i]) {
      desc->attrs = sChromeAttributes[i].flags;
      desc->obj = wrapper;
      desc->setter = sChromeAttributes[i].setter;
      desc->getter = sChromeAttributes[i].getter;
      return true;
    }
  }

  return true;
}

bool
EnumerateProperties(JS::AutoIdVector& props)
{
  for (size_t i = 0; i < sizeof(sMethods_ids); ++i) {
    if ((sMethods[i].flags & JSPROP_ENUMERATE) &&
        !props.append(sMethods_ids[i])) {
      return false;
    }
  }

  for (size_t i = 0; i < sizeof(sChromeAttributes_ids); ++i) {
    if ((sChromeAttributes[i].flags & JSPROP_ENUMERATE) &&
        !props.append(sChromeAttributes_ids[i])) {
      return false;
    }
  }

  return true;
}

JSObject*
Wrap(JSContext* aCx, JSObject* aScope, mozilla::dom::workers::XMLHttpRequest* aObject, bool* aTriedToWrap)
{

  *aTriedToWrap = true;
  return aObject->GetJSObject();
}

} // namespace XMLHttpRequest_workers

} // namespace prototypes
} // namespace bindings
} // namespace dom
} // namespace mozilla