/* THIS FILE IS AUTOGENERATED - DO NOT EDIT */

#include "AccessCheck.h"
#include "WorkerPrivate.h"
#include "XPCQuickStubs.h"
#include "mozilla/dom/bindings/EventTargetBinding.h"
#include "mozilla/dom/bindings/Nullable.h"
#include "mozilla/dom/bindings/XMLHttpRequestEventTargetBinding.h"
#include "mozilla/dom/bindings/XMLHttpRequestUploadBinding.h"
#include "mozilla/dom/workers/bindings/XMLHttpRequestUpload.h"
#include "nsContentUtils.h"
#include "nsXMLHttpRequest.h"

namespace mozilla {
namespace dom {
namespace bindings {
namespace prototypes {

namespace XMLHttpRequestUpload {

static JSBool
_AddProperty(JSContext* cx, JSObject* obj, jsid id, jsval* vp)
{

  MOZ_ASSERT(js::GetObjectJSClass(obj) == Class.ToJSClass());
  nsXMLHttpRequestUpload* self = UnwrapDOMObject<nsXMLHttpRequestUpload>(obj, Class.ToJSClass());

  JSCompartment* compartment = js::GetObjectCompartment(obj);
  xpc::CompartmentPrivate* priv =
    static_cast<xpc::CompartmentPrivate*>(JS_GetCompartmentPrivate(compartment));
  if (!priv->RegisterDOMExpandoObject(obj)) {
    return false;
  }
  self->SetPreservingWrapper(true);
  return true;
}

static nsISupports*
NativeToSupports(nsXMLHttpRequestUpload* aNative)
{
  return static_cast<nsDOMEventTargetHelper*>(
    static_cast<nsXHREventTarget*>(
      aNative));
}

static void
_Finalize(JSFreeOp* fop, JSObject* obj)
{

  MOZ_ASSERT(js::GetObjectJSClass(obj) == Class.ToJSClass());
  nsXMLHttpRequestUpload* self = UnwrapDOMObject<nsXMLHttpRequestUpload>(obj, Class.ToJSClass());

  self->ClearWrapper();

  XPCJSRuntime *rt = nsXPConnect::GetRuntimeInstance();
  if (rt) {
    rt->DeferredRelease(NativeToSupports(self));
  } else {
    NS_RELEASE(self);
  }
}

const NativePropertyHooks NativeHooks = { ResolveProperty, EnumerateProperties, &XMLHttpRequestEventTarget::NativeHooks };

DOMJSClass Class = {
  { "XMLHttpRequestUpload",
    JSCLASS_IS_DOMJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(1),
    _AddProperty, /* addProperty */
    JS_PropertyStub,       /* delProperty */
    JS_PropertyStub,       /* getProperty */
    JS_StrictPropertyStub, /* setProperty */
    JS_EnumerateStub,
    JS_ResolveStub,
    JS_ConvertStub,
    _Finalize, /* finalize */
    NULL,                  /* checkAccess */
    NULL,                  /* call */
    NULL,                  /* construct */
    NULL,                  /* hasInstance */
    NULL, /* trace */
    JSCLASS_NO_INTERNAL_MEMBERS
  },
  { id::EventTarget, id::XMLHttpRequestEventTarget, id::XMLHttpRequestUpload },
  -1, true, DOM_OBJECT_SLOT,
  &NativeHooks
};

static JSClass PrototypeClass = {
  "XMLHttpRequestUpload Prototype", 0,
  JS_PropertyStub,       /* addProperty */
  JS_PropertyStub,       /* delProperty */
  JS_PropertyStub,       /* getProperty */
  JS_StrictPropertyStub, /* setProperty */
  JS_EnumerateStub,
  JS_ResolveStub,
  JS_ConvertStub,
  NULL,                  /* finalize */
  NULL,                  /* checkAccess */
  NULL,                  /* call */
  NULL,                  /* construct */
  NULL,                  /* hasInstance */
  NULL,                  /* trace */
  JSCLASS_NO_INTERNAL_MEMBERS
};

JSObject*
CreateInterfaceObjects(JSContext* aCx, JSObject* aGlobal, JSObject* aReceiver)
{
  JSObject* parentProto = XMLHttpRequestEventTarget::GetProtoObject(aCx, aGlobal, aReceiver);
  if (!parentProto) {
    return NULL;
  }
  return bindings::CreateInterfaceObjects(aCx, aGlobal, aReceiver, parentProto,
                                          &PrototypeClass, NULL, ThrowingConstructor, 0,
                                          NULL, NULL, NULL, NULL,
                                          "XMLHttpRequestUpload");
}

bool
ResolveProperty(JSContext* cx, JSObject* wrapper, jsid id, bool set, JSPropertyDescriptor* desc)
{
  return true;
}

bool
EnumerateProperties(JS::AutoIdVector& props)
{
  return true;
}

bool
DefineDOMInterface(JSContext* aCx, JSObject* aReceiver, bool* aEnabled)
{
  JSObject* global = JS_GetGlobalForObject(aCx, aReceiver);

  {
    XPCWrappedNativeScope* scope =
      XPCWrappedNativeScope::FindInJSObjectScope(aCx, global);
    if (!scope) {
      return false;
    }

    if (!scope->ParisBindingsEnabled()) {
      *aEnabled = false;
      return false;
    }
  }

  *aEnabled = true;
  return !!GetProtoObject(aCx, global, aReceiver);
}

JSObject*
Wrap(JSContext* aCx, JSObject* aScope, nsXMLHttpRequestUpload* aObject, bool* aTriedToWrap)
{

  *aTriedToWrap = true;

  JSObject* parent = bindings::WrapNativeParent(aCx, aScope, aObject->GetParentObject());
  if (!parent) {
    return NULL;
  }

  JSAutoEnterCompartment ac;
  if (js::GetGlobalForObjectCrossCompartment(parent) != aScope) {
    if (!ac.enter(aCx, parent)) {
      return NULL;
    }
  }

  JSObject* global = JS_GetGlobalForObject(aCx, parent);

  {
    XPCWrappedNativeScope* scope =
      XPCWrappedNativeScope::FindInJSObjectScope(aCx, global);
    if (!scope) {
      return NULL;
    }

    if (!scope->ParisBindingsEnabled()) {
      aObject->ClearIsDOMBinding();
      *aTriedToWrap = false;
      return NULL;
    }
  }

  JSObject* proto = GetProtoObject(aCx, global, global);
  if (!proto) {
    return NULL;
  }

  JSObject* obj = JS_NewObject(aCx, &Class.mBase, proto, parent);
  if (!obj) {
    return NULL;
  }

  js::SetReservedSlot(obj, DOM_OBJECT_SLOT, PRIVATE_TO_JSVAL(aObject));
  NS_ADDREF(aObject);

  aObject->SetWrapper(obj);

  return obj;
}

} // namespace XMLHttpRequestUpload

namespace XMLHttpRequestUpload_workers {

static void
_Finalize(JSFreeOp* fop, JSObject* obj)
{

  MOZ_ASSERT(js::GetObjectJSClass(obj) == Class.ToJSClass());
  mozilla::dom::workers::XMLHttpRequestUpload* self = UnwrapDOMObject<mozilla::dom::workers::XMLHttpRequestUpload>(obj, Class.ToJSClass());
  if (self) {
    self->_Finalize(fop);
  }
}

static void
_Trace(JSTracer* trc, JSObject* obj)
{

  MOZ_ASSERT(js::GetObjectJSClass(obj) == Class.ToJSClass());
  mozilla::dom::workers::XMLHttpRequestUpload* self = UnwrapDOMObject<mozilla::dom::workers::XMLHttpRequestUpload>(obj, Class.ToJSClass());
  if (self) {
    self->_Trace(trc);
  }
}

const NativePropertyHooks NativeHooks = { ResolveProperty, EnumerateProperties, &XMLHttpRequestEventTarget::NativeHooks };

DOMJSClass Class = {
  { "XMLHttpRequestUpload",
    JSCLASS_IS_DOMJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(1),
    JS_PropertyStub, /* addProperty */
    JS_PropertyStub,       /* delProperty */
    JS_PropertyStub,       /* getProperty */
    JS_StrictPropertyStub, /* setProperty */
    JS_EnumerateStub,
    JS_ResolveStub,
    JS_ConvertStub,
    _Finalize, /* finalize */
    NULL,                  /* checkAccess */
    NULL,                  /* call */
    NULL,                  /* construct */
    NULL,                  /* hasInstance */
    _Trace, /* trace */
    JSCLASS_NO_INTERNAL_MEMBERS
  },
  { id::EventTarget_workers, id::XMLHttpRequestEventTarget_workers, id::XMLHttpRequestUpload_workers },
  -1, false, DOM_OBJECT_SLOT,
  &NativeHooks
};

static JSClass PrototypeClass = {
  "XMLHttpRequestUpload Prototype", 0,
  JS_PropertyStub,       /* addProperty */
  JS_PropertyStub,       /* delProperty */
  JS_PropertyStub,       /* getProperty */
  JS_StrictPropertyStub, /* setProperty */
  JS_EnumerateStub,
  JS_ResolveStub,
  JS_ConvertStub,
  NULL,                  /* finalize */
  NULL,                  /* checkAccess */
  NULL,                  /* call */
  NULL,                  /* construct */
  NULL,                  /* hasInstance */
  NULL,                  /* trace */
  JSCLASS_NO_INTERNAL_MEMBERS
};

JSObject*
CreateInterfaceObjects(JSContext* aCx, JSObject* aGlobal, JSObject* aReceiver)
{
  JSObject* parentProto = XMLHttpRequestEventTarget_workers::GetProtoObject(aCx, aGlobal, aReceiver);
  if (!parentProto) {
    return NULL;
  }
  return bindings::CreateInterfaceObjects(aCx, aGlobal, aReceiver, parentProto,
                                          &PrototypeClass, NULL, ThrowingConstructorWorkers, 0,
                                          NULL, NULL, NULL, NULL,
                                          "XMLHttpRequestUpload");
}

bool
ResolveProperty(JSContext* cx, JSObject* wrapper, jsid id, bool set, JSPropertyDescriptor* desc)
{
  return true;
}

bool
EnumerateProperties(JS::AutoIdVector& props)
{
  return true;
}

JSObject*
Wrap(JSContext* aCx, JSObject* aScope, mozilla::dom::workers::XMLHttpRequestUpload* aObject, bool* aTriedToWrap)
{

  *aTriedToWrap = true;
  return aObject->GetJSObject();
}

} // namespace XMLHttpRequestUpload_workers

} // namespace prototypes
} // namespace bindings
} // namespace dom
} // namespace mozilla